// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>The HTTP package configuration properties for the requested VOD source.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct HttpPackageConfiguration {
    /// <p>The relative path to the URL for this VOD source. This is combined with SourceLocation::HttpConfiguration::BaseUrl to form a valid URL.</p>
    pub path: std::option::Option<std::string::String>,
    /// <p>The name of the source group. This has to match one of the Channel::Outputs::SourceGroup.</p>
    pub source_group: std::option::Option<std::string::String>,
    /// <p>The streaming protocol for this package configuration. Supported values are HLS and DASH.</p>
    pub r#type: std::option::Option<crate::model::Type>,
}
impl HttpPackageConfiguration {
    /// <p>The relative path to the URL for this VOD source. This is combined with SourceLocation::HttpConfiguration::BaseUrl to form a valid URL.</p>
    pub fn path(&self) -> std::option::Option<&str> {
        self.path.as_deref()
    }
    /// <p>The name of the source group. This has to match one of the Channel::Outputs::SourceGroup.</p>
    pub fn source_group(&self) -> std::option::Option<&str> {
        self.source_group.as_deref()
    }
    /// <p>The streaming protocol for this package configuration. Supported values are HLS and DASH.</p>
    pub fn r#type(&self) -> std::option::Option<&crate::model::Type> {
        self.r#type.as_ref()
    }
}
impl std::fmt::Debug for HttpPackageConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("HttpPackageConfiguration");
        formatter.field("path", &self.path);
        formatter.field("source_group", &self.source_group);
        formatter.field("r#type", &self.r#type);
        formatter.finish()
    }
}
/// See [`HttpPackageConfiguration`](crate::model::HttpPackageConfiguration)
pub mod http_package_configuration {
    /// A builder for [`HttpPackageConfiguration`](crate::model::HttpPackageConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) path: std::option::Option<std::string::String>,
        pub(crate) source_group: std::option::Option<std::string::String>,
        pub(crate) r#type: std::option::Option<crate::model::Type>,
    }
    impl Builder {
        /// <p>The relative path to the URL for this VOD source. This is combined with SourceLocation::HttpConfiguration::BaseUrl to form a valid URL.</p>
        pub fn path(mut self, input: impl Into<std::string::String>) -> Self {
            self.path = Some(input.into());
            self
        }
        /// <p>The relative path to the URL for this VOD source. This is combined with SourceLocation::HttpConfiguration::BaseUrl to form a valid URL.</p>
        pub fn set_path(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.path = input;
            self
        }
        /// <p>The name of the source group. This has to match one of the Channel::Outputs::SourceGroup.</p>
        pub fn source_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_group = Some(input.into());
            self
        }
        /// <p>The name of the source group. This has to match one of the Channel::Outputs::SourceGroup.</p>
        pub fn set_source_group(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.source_group = input;
            self
        }
        /// <p>The streaming protocol for this package configuration. Supported values are HLS and DASH.</p>
        pub fn r#type(mut self, input: crate::model::Type) -> Self {
            self.r#type = Some(input);
            self
        }
        /// <p>The streaming protocol for this package configuration. Supported values are HLS and DASH.</p>
        pub fn set_type(mut self, input: std::option::Option<crate::model::Type>) -> Self {
            self.r#type = input;
            self
        }
        /// Consumes the builder and constructs a [`HttpPackageConfiguration`](crate::model::HttpPackageConfiguration)
        pub fn build(self) -> crate::model::HttpPackageConfiguration {
            crate::model::HttpPackageConfiguration {
                path: self.path,
                source_group: self.source_group,
                r#type: self.r#type,
            }
        }
    }
}
impl HttpPackageConfiguration {
    /// Creates a new builder-style object to manufacture [`HttpPackageConfiguration`](crate::model::HttpPackageConfiguration)
    pub fn builder() -> crate::model::http_package_configuration::Builder {
        crate::model::http_package_configuration::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum Type {
    #[allow(missing_docs)] // documentation missing in model
    Dash,
    #[allow(missing_docs)] // documentation missing in model
    Hls,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for Type {
    fn from(s: &str) -> Self {
        match s {
            "DASH" => Type::Dash,
            "HLS" => Type::Hls,
            other => Type::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for Type {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(Type::from(s))
    }
}
impl Type {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            Type::Dash => "DASH",
            Type::Hls => "HLS",
            Type::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["DASH", "HLS"]
    }
}
impl AsRef<str> for Type {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>The HTTP configuration for the source location.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct HttpConfiguration {
    /// <p>The base URL for the source location host server. This string must include the protocol, such as <b>https://</b>.</p>
    pub base_url: std::option::Option<std::string::String>,
}
impl HttpConfiguration {
    /// <p>The base URL for the source location host server. This string must include the protocol, such as <b>https://</b>.</p>
    pub fn base_url(&self) -> std::option::Option<&str> {
        self.base_url.as_deref()
    }
}
impl std::fmt::Debug for HttpConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("HttpConfiguration");
        formatter.field("base_url", &self.base_url);
        formatter.finish()
    }
}
/// See [`HttpConfiguration`](crate::model::HttpConfiguration)
pub mod http_configuration {
    /// A builder for [`HttpConfiguration`](crate::model::HttpConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) base_url: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The base URL for the source location host server. This string must include the protocol, such as <b>https://</b>.</p>
        pub fn base_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.base_url = Some(input.into());
            self
        }
        /// <p>The base URL for the source location host server. This string must include the protocol, such as <b>https://</b>.</p>
        pub fn set_base_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.base_url = input;
            self
        }
        /// Consumes the builder and constructs a [`HttpConfiguration`](crate::model::HttpConfiguration)
        pub fn build(self) -> crate::model::HttpConfiguration {
            crate::model::HttpConfiguration {
                base_url: self.base_url,
            }
        }
    }
}
impl HttpConfiguration {
    /// Creates a new builder-style object to manufacture [`HttpConfiguration`](crate::model::HttpConfiguration)
    pub fn builder() -> crate::model::http_configuration::Builder {
        crate::model::http_configuration::Builder::default()
    }
}

/// <p>The optional configuration for a server that serves segments. Use this if you want the segment delivery server to be different from the source location server. For example, you can configure your source location server to be an origination server, such as MediaPackage, and the segment delivery server to be a content delivery network (CDN), such as CloudFront. If you don't specify a segment delivery server, then the source location server is used.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DefaultSegmentDeliveryConfiguration {
    /// <p>The hostname of the server that will be used to serve segments. This string must include the protocol, such as <b>https://</b>.</p>
    pub base_url: std::option::Option<std::string::String>,
}
impl DefaultSegmentDeliveryConfiguration {
    /// <p>The hostname of the server that will be used to serve segments. This string must include the protocol, such as <b>https://</b>.</p>
    pub fn base_url(&self) -> std::option::Option<&str> {
        self.base_url.as_deref()
    }
}
impl std::fmt::Debug for DefaultSegmentDeliveryConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DefaultSegmentDeliveryConfiguration");
        formatter.field("base_url", &self.base_url);
        formatter.finish()
    }
}
/// See [`DefaultSegmentDeliveryConfiguration`](crate::model::DefaultSegmentDeliveryConfiguration)
pub mod default_segment_delivery_configuration {
    /// A builder for [`DefaultSegmentDeliveryConfiguration`](crate::model::DefaultSegmentDeliveryConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) base_url: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The hostname of the server that will be used to serve segments. This string must include the protocol, such as <b>https://</b>.</p>
        pub fn base_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.base_url = Some(input.into());
            self
        }
        /// <p>The hostname of the server that will be used to serve segments. This string must include the protocol, such as <b>https://</b>.</p>
        pub fn set_base_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.base_url = input;
            self
        }
        /// Consumes the builder and constructs a [`DefaultSegmentDeliveryConfiguration`](crate::model::DefaultSegmentDeliveryConfiguration)
        pub fn build(self) -> crate::model::DefaultSegmentDeliveryConfiguration {
            crate::model::DefaultSegmentDeliveryConfiguration {
                base_url: self.base_url,
            }
        }
    }
}
impl DefaultSegmentDeliveryConfiguration {
    /// Creates a new builder-style object to manufacture [`DefaultSegmentDeliveryConfiguration`](crate::model::DefaultSegmentDeliveryConfiguration)
    pub fn builder() -> crate::model::default_segment_delivery_configuration::Builder {
        crate::model::default_segment_delivery_configuration::Builder::default()
    }
}

/// <p>Access configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AccessConfiguration {
    /// <p>The type of authentication used to access content from HttpConfiguration::BaseUrl on your source location. Accepted value: S3_SIGV4.</p> <p>S3_SIGV4 - AWS Signature Version 4 authentication for Amazon S3 hosted virtual-style access. If your source location base URL is an Amazon S3 bucket, MediaTailor can use AWS Signature Version 4 (SigV4) authentication to access the bucket where your source content is stored. Your MediaTailor source location baseURL must follow the S3 virtual hosted-style request URL format. For example, https://bucket-name.s3.Region.amazonaws.com/key-name.</p> <p>Before you can use S3_SIGV4, you must meet these requirements:</p> <p>• You must allow MediaTailor to access your S3 bucket by granting mediatailor.amazonaws.com principal access in IAM. For information about configuring access in IAM, see Access management in the IAM User Guide.</p> <p>• The mediatailor.amazonaws.com service principal must have permissions to read all top level manifests referenced by the VodSource packaging configurations.</p> <p>• The caller of the API must have s3:GetObject IAM permissions to read all top level manifests referenced by your MediaTailor VodSource packaging configurations.</p>
    pub access_type: std::option::Option<crate::model::AccessType>,
    /// <p>AWS Secrets Manager access token configuration parameters.</p>
    pub secrets_manager_access_token_configuration:
        std::option::Option<crate::model::SecretsManagerAccessTokenConfiguration>,
}
impl AccessConfiguration {
    /// <p>The type of authentication used to access content from HttpConfiguration::BaseUrl on your source location. Accepted value: S3_SIGV4.</p> <p>S3_SIGV4 - AWS Signature Version 4 authentication for Amazon S3 hosted virtual-style access. If your source location base URL is an Amazon S3 bucket, MediaTailor can use AWS Signature Version 4 (SigV4) authentication to access the bucket where your source content is stored. Your MediaTailor source location baseURL must follow the S3 virtual hosted-style request URL format. For example, https://bucket-name.s3.Region.amazonaws.com/key-name.</p> <p>Before you can use S3_SIGV4, you must meet these requirements:</p> <p>• You must allow MediaTailor to access your S3 bucket by granting mediatailor.amazonaws.com principal access in IAM. For information about configuring access in IAM, see Access management in the IAM User Guide.</p> <p>• The mediatailor.amazonaws.com service principal must have permissions to read all top level manifests referenced by the VodSource packaging configurations.</p> <p>• The caller of the API must have s3:GetObject IAM permissions to read all top level manifests referenced by your MediaTailor VodSource packaging configurations.</p>
    pub fn access_type(&self) -> std::option::Option<&crate::model::AccessType> {
        self.access_type.as_ref()
    }
    /// <p>AWS Secrets Manager access token configuration parameters.</p>
    pub fn secrets_manager_access_token_configuration(
        &self,
    ) -> std::option::Option<&crate::model::SecretsManagerAccessTokenConfiguration> {
        self.secrets_manager_access_token_configuration.as_ref()
    }
}
impl std::fmt::Debug for AccessConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AccessConfiguration");
        formatter.field("access_type", &self.access_type);
        formatter.field(
            "secrets_manager_access_token_configuration",
            &self.secrets_manager_access_token_configuration,
        );
        formatter.finish()
    }
}
/// See [`AccessConfiguration`](crate::model::AccessConfiguration)
pub mod access_configuration {
    /// A builder for [`AccessConfiguration`](crate::model::AccessConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) access_type: std::option::Option<crate::model::AccessType>,
        pub(crate) secrets_manager_access_token_configuration:
            std::option::Option<crate::model::SecretsManagerAccessTokenConfiguration>,
    }
    impl Builder {
        /// <p>The type of authentication used to access content from HttpConfiguration::BaseUrl on your source location. Accepted value: S3_SIGV4.</p> <p>S3_SIGV4 - AWS Signature Version 4 authentication for Amazon S3 hosted virtual-style access. If your source location base URL is an Amazon S3 bucket, MediaTailor can use AWS Signature Version 4 (SigV4) authentication to access the bucket where your source content is stored. Your MediaTailor source location baseURL must follow the S3 virtual hosted-style request URL format. For example, https://bucket-name.s3.Region.amazonaws.com/key-name.</p> <p>Before you can use S3_SIGV4, you must meet these requirements:</p> <p>• You must allow MediaTailor to access your S3 bucket by granting mediatailor.amazonaws.com principal access in IAM. For information about configuring access in IAM, see Access management in the IAM User Guide.</p> <p>• The mediatailor.amazonaws.com service principal must have permissions to read all top level manifests referenced by the VodSource packaging configurations.</p> <p>• The caller of the API must have s3:GetObject IAM permissions to read all top level manifests referenced by your MediaTailor VodSource packaging configurations.</p>
        pub fn access_type(mut self, input: crate::model::AccessType) -> Self {
            self.access_type = Some(input);
            self
        }
        /// <p>The type of authentication used to access content from HttpConfiguration::BaseUrl on your source location. Accepted value: S3_SIGV4.</p> <p>S3_SIGV4 - AWS Signature Version 4 authentication for Amazon S3 hosted virtual-style access. If your source location base URL is an Amazon S3 bucket, MediaTailor can use AWS Signature Version 4 (SigV4) authentication to access the bucket where your source content is stored. Your MediaTailor source location baseURL must follow the S3 virtual hosted-style request URL format. For example, https://bucket-name.s3.Region.amazonaws.com/key-name.</p> <p>Before you can use S3_SIGV4, you must meet these requirements:</p> <p>• You must allow MediaTailor to access your S3 bucket by granting mediatailor.amazonaws.com principal access in IAM. For information about configuring access in IAM, see Access management in the IAM User Guide.</p> <p>• The mediatailor.amazonaws.com service principal must have permissions to read all top level manifests referenced by the VodSource packaging configurations.</p> <p>• The caller of the API must have s3:GetObject IAM permissions to read all top level manifests referenced by your MediaTailor VodSource packaging configurations.</p>
        pub fn set_access_type(
            mut self,
            input: std::option::Option<crate::model::AccessType>,
        ) -> Self {
            self.access_type = input;
            self
        }
        /// <p>AWS Secrets Manager access token configuration parameters.</p>
        pub fn secrets_manager_access_token_configuration(
            mut self,
            input: crate::model::SecretsManagerAccessTokenConfiguration,
        ) -> Self {
            self.secrets_manager_access_token_configuration = Some(input);
            self
        }
        /// <p>AWS Secrets Manager access token configuration parameters.</p>
        pub fn set_secrets_manager_access_token_configuration(
            mut self,
            input: std::option::Option<crate::model::SecretsManagerAccessTokenConfiguration>,
        ) -> Self {
            self.secrets_manager_access_token_configuration = input;
            self
        }
        /// Consumes the builder and constructs a [`AccessConfiguration`](crate::model::AccessConfiguration)
        pub fn build(self) -> crate::model::AccessConfiguration {
            crate::model::AccessConfiguration {
                access_type: self.access_type,
                secrets_manager_access_token_configuration: self
                    .secrets_manager_access_token_configuration,
            }
        }
    }
}
impl AccessConfiguration {
    /// Creates a new builder-style object to manufacture [`AccessConfiguration`](crate::model::AccessConfiguration)
    pub fn builder() -> crate::model::access_configuration::Builder {
        crate::model::access_configuration::Builder::default()
    }
}

/// <p>AWS Secrets Manager access token configuration parameters. For information about Secrets Manager access token authentication, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/channel-assembly-access-configuration-access-token.html">Working with AWS Secrets Manager access token authentication</a>.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SecretsManagerAccessTokenConfiguration {
    /// <p>The name of the HTTP header used to supply the access token in requests to the source location.</p>
    pub header_name: std::option::Option<std::string::String>,
    /// <p>The Amazon Resource Name (ARN) of the AWS Secrets Manager secret that contains the access token.</p>
    pub secret_arn: std::option::Option<std::string::String>,
    /// <p>The AWS Secrets Manager <a href="https://docs.aws.amazon.com/secretsmanager/latest/apireference/API_CreateSecret.html#SecretsManager-CreateSecret-request-SecretString.html">SecretString</a> key associated with the access token. MediaTailor uses the key to look up SecretString key and value pair containing the access token.</p>
    pub secret_string_key: std::option::Option<std::string::String>,
}
impl SecretsManagerAccessTokenConfiguration {
    /// <p>The name of the HTTP header used to supply the access token in requests to the source location.</p>
    pub fn header_name(&self) -> std::option::Option<&str> {
        self.header_name.as_deref()
    }
    /// <p>The Amazon Resource Name (ARN) of the AWS Secrets Manager secret that contains the access token.</p>
    pub fn secret_arn(&self) -> std::option::Option<&str> {
        self.secret_arn.as_deref()
    }
    /// <p>The AWS Secrets Manager <a href="https://docs.aws.amazon.com/secretsmanager/latest/apireference/API_CreateSecret.html#SecretsManager-CreateSecret-request-SecretString.html">SecretString</a> key associated with the access token. MediaTailor uses the key to look up SecretString key and value pair containing the access token.</p>
    pub fn secret_string_key(&self) -> std::option::Option<&str> {
        self.secret_string_key.as_deref()
    }
}
impl std::fmt::Debug for SecretsManagerAccessTokenConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SecretsManagerAccessTokenConfiguration");
        formatter.field("header_name", &self.header_name);
        formatter.field("secret_arn", &self.secret_arn);
        formatter.field("secret_string_key", &self.secret_string_key);
        formatter.finish()
    }
}
/// See [`SecretsManagerAccessTokenConfiguration`](crate::model::SecretsManagerAccessTokenConfiguration)
pub mod secrets_manager_access_token_configuration {
    /// A builder for [`SecretsManagerAccessTokenConfiguration`](crate::model::SecretsManagerAccessTokenConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) header_name: std::option::Option<std::string::String>,
        pub(crate) secret_arn: std::option::Option<std::string::String>,
        pub(crate) secret_string_key: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The name of the HTTP header used to supply the access token in requests to the source location.</p>
        pub fn header_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.header_name = Some(input.into());
            self
        }
        /// <p>The name of the HTTP header used to supply the access token in requests to the source location.</p>
        pub fn set_header_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.header_name = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the AWS Secrets Manager secret that contains the access token.</p>
        pub fn secret_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.secret_arn = Some(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the AWS Secrets Manager secret that contains the access token.</p>
        pub fn set_secret_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.secret_arn = input;
            self
        }
        /// <p>The AWS Secrets Manager <a href="https://docs.aws.amazon.com/secretsmanager/latest/apireference/API_CreateSecret.html#SecretsManager-CreateSecret-request-SecretString.html">SecretString</a> key associated with the access token. MediaTailor uses the key to look up SecretString key and value pair containing the access token.</p>
        pub fn secret_string_key(mut self, input: impl Into<std::string::String>) -> Self {
            self.secret_string_key = Some(input.into());
            self
        }
        /// <p>The AWS Secrets Manager <a href="https://docs.aws.amazon.com/secretsmanager/latest/apireference/API_CreateSecret.html#SecretsManager-CreateSecret-request-SecretString.html">SecretString</a> key associated with the access token. MediaTailor uses the key to look up SecretString key and value pair containing the access token.</p>
        pub fn set_secret_string_key(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.secret_string_key = input;
            self
        }
        /// Consumes the builder and constructs a [`SecretsManagerAccessTokenConfiguration`](crate::model::SecretsManagerAccessTokenConfiguration)
        pub fn build(self) -> crate::model::SecretsManagerAccessTokenConfiguration {
            crate::model::SecretsManagerAccessTokenConfiguration {
                header_name: self.header_name,
                secret_arn: self.secret_arn,
                secret_string_key: self.secret_string_key,
            }
        }
    }
}
impl SecretsManagerAccessTokenConfiguration {
    /// Creates a new builder-style object to manufacture [`SecretsManagerAccessTokenConfiguration`](crate::model::SecretsManagerAccessTokenConfiguration)
    pub fn builder() -> crate::model::secrets_manager_access_token_configuration::Builder {
        crate::model::secrets_manager_access_token_configuration::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum AccessType {
    #[allow(missing_docs)] // documentation missing in model
    S3Sigv4,
    #[allow(missing_docs)] // documentation missing in model
    SecretsManagerAccessToken,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for AccessType {
    fn from(s: &str) -> Self {
        match s {
            "S3_SIGV4" => AccessType::S3Sigv4,
            "SECRETS_MANAGER_ACCESS_TOKEN" => AccessType::SecretsManagerAccessToken,
            other => AccessType::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for AccessType {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(AccessType::from(s))
    }
}
impl AccessType {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            AccessType::S3Sigv4 => "S3_SIGV4",
            AccessType::SecretsManagerAccessToken => "SECRETS_MANAGER_ACCESS_TOKEN",
            AccessType::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["S3_SIGV4", "SECRETS_MANAGER_ACCESS_TOKEN"]
    }
}
impl AsRef<str> for AccessType {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>This response includes only the "property" : "type" property.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ResponseOutputItem {
    /// <p>DASH manifest configuration settings.</p>
    pub dash_playlist_settings: std::option::Option<crate::model::DashPlaylistSettings>,
    /// <p>HLS manifest configuration settings.</p>
    pub hls_playlist_settings: std::option::Option<crate::model::HlsPlaylistSettings>,
    /// <p>The name of the manifest for the channel that will appear in the channel output's playback URL.</p>
    pub manifest_name: std::option::Option<std::string::String>,
    /// <p>The URL used for playback by content players.</p>
    pub playback_url: std::option::Option<std::string::String>,
    /// <p>A string used to associate a package configuration source group with a channel output.</p>
    pub source_group: std::option::Option<std::string::String>,
}
impl ResponseOutputItem {
    /// <p>DASH manifest configuration settings.</p>
    pub fn dash_playlist_settings(
        &self,
    ) -> std::option::Option<&crate::model::DashPlaylistSettings> {
        self.dash_playlist_settings.as_ref()
    }
    /// <p>HLS manifest configuration settings.</p>
    pub fn hls_playlist_settings(&self) -> std::option::Option<&crate::model::HlsPlaylistSettings> {
        self.hls_playlist_settings.as_ref()
    }
    /// <p>The name of the manifest for the channel that will appear in the channel output's playback URL.</p>
    pub fn manifest_name(&self) -> std::option::Option<&str> {
        self.manifest_name.as_deref()
    }
    /// <p>The URL used for playback by content players.</p>
    pub fn playback_url(&self) -> std::option::Option<&str> {
        self.playback_url.as_deref()
    }
    /// <p>A string used to associate a package configuration source group with a channel output.</p>
    pub fn source_group(&self) -> std::option::Option<&str> {
        self.source_group.as_deref()
    }
}
impl std::fmt::Debug for ResponseOutputItem {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ResponseOutputItem");
        formatter.field("dash_playlist_settings", &self.dash_playlist_settings);
        formatter.field("hls_playlist_settings", &self.hls_playlist_settings);
        formatter.field("manifest_name", &self.manifest_name);
        formatter.field("playback_url", &self.playback_url);
        formatter.field("source_group", &self.source_group);
        formatter.finish()
    }
}
/// See [`ResponseOutputItem`](crate::model::ResponseOutputItem)
pub mod response_output_item {
    /// A builder for [`ResponseOutputItem`](crate::model::ResponseOutputItem)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dash_playlist_settings: std::option::Option<crate::model::DashPlaylistSettings>,
        pub(crate) hls_playlist_settings: std::option::Option<crate::model::HlsPlaylistSettings>,
        pub(crate) manifest_name: std::option::Option<std::string::String>,
        pub(crate) playback_url: std::option::Option<std::string::String>,
        pub(crate) source_group: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>DASH manifest configuration settings.</p>
        pub fn dash_playlist_settings(mut self, input: crate::model::DashPlaylistSettings) -> Self {
            self.dash_playlist_settings = Some(input);
            self
        }
        /// <p>DASH manifest configuration settings.</p>
        pub fn set_dash_playlist_settings(
            mut self,
            input: std::option::Option<crate::model::DashPlaylistSettings>,
        ) -> Self {
            self.dash_playlist_settings = input;
            self
        }
        /// <p>HLS manifest configuration settings.</p>
        pub fn hls_playlist_settings(mut self, input: crate::model::HlsPlaylistSettings) -> Self {
            self.hls_playlist_settings = Some(input);
            self
        }
        /// <p>HLS manifest configuration settings.</p>
        pub fn set_hls_playlist_settings(
            mut self,
            input: std::option::Option<crate::model::HlsPlaylistSettings>,
        ) -> Self {
            self.hls_playlist_settings = input;
            self
        }
        /// <p>The name of the manifest for the channel that will appear in the channel output's playback URL.</p>
        pub fn manifest_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.manifest_name = Some(input.into());
            self
        }
        /// <p>The name of the manifest for the channel that will appear in the channel output's playback URL.</p>
        pub fn set_manifest_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.manifest_name = input;
            self
        }
        /// <p>The URL used for playback by content players.</p>
        pub fn playback_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.playback_url = Some(input.into());
            self
        }
        /// <p>The URL used for playback by content players.</p>
        pub fn set_playback_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.playback_url = input;
            self
        }
        /// <p>A string used to associate a package configuration source group with a channel output.</p>
        pub fn source_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_group = Some(input.into());
            self
        }
        /// <p>A string used to associate a package configuration source group with a channel output.</p>
        pub fn set_source_group(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.source_group = input;
            self
        }
        /// Consumes the builder and constructs a [`ResponseOutputItem`](crate::model::ResponseOutputItem)
        pub fn build(self) -> crate::model::ResponseOutputItem {
            crate::model::ResponseOutputItem {
                dash_playlist_settings: self.dash_playlist_settings,
                hls_playlist_settings: self.hls_playlist_settings,
                manifest_name: self.manifest_name,
                playback_url: self.playback_url,
                source_group: self.source_group,
            }
        }
    }
}
impl ResponseOutputItem {
    /// Creates a new builder-style object to manufacture [`ResponseOutputItem`](crate::model::ResponseOutputItem)
    pub fn builder() -> crate::model::response_output_item::Builder {
        crate::model::response_output_item::Builder::default()
    }
}

/// <p>HLS playlist configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct HlsPlaylistSettings {
    /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
    pub manifest_window_seconds: i32,
}
impl HlsPlaylistSettings {
    /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
    pub fn manifest_window_seconds(&self) -> i32 {
        self.manifest_window_seconds
    }
}
impl std::fmt::Debug for HlsPlaylistSettings {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("HlsPlaylistSettings");
        formatter.field("manifest_window_seconds", &self.manifest_window_seconds);
        formatter.finish()
    }
}
/// See [`HlsPlaylistSettings`](crate::model::HlsPlaylistSettings)
pub mod hls_playlist_settings {
    /// A builder for [`HlsPlaylistSettings`](crate::model::HlsPlaylistSettings)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) manifest_window_seconds: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
        pub fn manifest_window_seconds(mut self, input: i32) -> Self {
            self.manifest_window_seconds = Some(input);
            self
        }
        /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
        pub fn set_manifest_window_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.manifest_window_seconds = input;
            self
        }
        /// Consumes the builder and constructs a [`HlsPlaylistSettings`](crate::model::HlsPlaylistSettings)
        pub fn build(self) -> crate::model::HlsPlaylistSettings {
            crate::model::HlsPlaylistSettings {
                manifest_window_seconds: self.manifest_window_seconds.unwrap_or_default(),
            }
        }
    }
}
impl HlsPlaylistSettings {
    /// Creates a new builder-style object to manufacture [`HlsPlaylistSettings`](crate::model::HlsPlaylistSettings)
    pub fn builder() -> crate::model::hls_playlist_settings::Builder {
        crate::model::hls_playlist_settings::Builder::default()
    }
}

/// <p>Dash manifest configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DashPlaylistSettings {
    /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
    pub manifest_window_seconds: i32,
    /// <p>Minimum amount of content (measured in seconds) that a player must keep available in the buffer. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub min_buffer_time_seconds: i32,
    /// <p>Minimum amount of time (in seconds) that the player should wait before requesting updates to the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub min_update_period_seconds: i32,
    /// <p>Amount of time (in seconds) that the player should be from the live point at the end of the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub suggested_presentation_delay_seconds: i32,
}
impl DashPlaylistSettings {
    /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
    pub fn manifest_window_seconds(&self) -> i32 {
        self.manifest_window_seconds
    }
    /// <p>Minimum amount of content (measured in seconds) that a player must keep available in the buffer. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub fn min_buffer_time_seconds(&self) -> i32 {
        self.min_buffer_time_seconds
    }
    /// <p>Minimum amount of time (in seconds) that the player should wait before requesting updates to the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub fn min_update_period_seconds(&self) -> i32 {
        self.min_update_period_seconds
    }
    /// <p>Amount of time (in seconds) that the player should be from the live point at the end of the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
    pub fn suggested_presentation_delay_seconds(&self) -> i32 {
        self.suggested_presentation_delay_seconds
    }
}
impl std::fmt::Debug for DashPlaylistSettings {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DashPlaylistSettings");
        formatter.field("manifest_window_seconds", &self.manifest_window_seconds);
        formatter.field("min_buffer_time_seconds", &self.min_buffer_time_seconds);
        formatter.field("min_update_period_seconds", &self.min_update_period_seconds);
        formatter.field(
            "suggested_presentation_delay_seconds",
            &self.suggested_presentation_delay_seconds,
        );
        formatter.finish()
    }
}
/// See [`DashPlaylistSettings`](crate::model::DashPlaylistSettings)
pub mod dash_playlist_settings {
    /// A builder for [`DashPlaylistSettings`](crate::model::DashPlaylistSettings)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) manifest_window_seconds: std::option::Option<i32>,
        pub(crate) min_buffer_time_seconds: std::option::Option<i32>,
        pub(crate) min_update_period_seconds: std::option::Option<i32>,
        pub(crate) suggested_presentation_delay_seconds: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
        pub fn manifest_window_seconds(mut self, input: i32) -> Self {
            self.manifest_window_seconds = Some(input);
            self
        }
        /// <p>The total duration (in seconds) of each manifest. Minimum value: 30 seconds. Maximum value: 3600 seconds.</p>
        pub fn set_manifest_window_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.manifest_window_seconds = input;
            self
        }
        /// <p>Minimum amount of content (measured in seconds) that a player must keep available in the buffer. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn min_buffer_time_seconds(mut self, input: i32) -> Self {
            self.min_buffer_time_seconds = Some(input);
            self
        }
        /// <p>Minimum amount of content (measured in seconds) that a player must keep available in the buffer. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn set_min_buffer_time_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.min_buffer_time_seconds = input;
            self
        }
        /// <p>Minimum amount of time (in seconds) that the player should wait before requesting updates to the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn min_update_period_seconds(mut self, input: i32) -> Self {
            self.min_update_period_seconds = Some(input);
            self
        }
        /// <p>Minimum amount of time (in seconds) that the player should wait before requesting updates to the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn set_min_update_period_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.min_update_period_seconds = input;
            self
        }
        /// <p>Amount of time (in seconds) that the player should be from the live point at the end of the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn suggested_presentation_delay_seconds(mut self, input: i32) -> Self {
            self.suggested_presentation_delay_seconds = Some(input);
            self
        }
        /// <p>Amount of time (in seconds) that the player should be from the live point at the end of the manifest. Minimum value: 2 seconds. Maximum value: 60 seconds.</p>
        pub fn set_suggested_presentation_delay_seconds(
            mut self,
            input: std::option::Option<i32>,
        ) -> Self {
            self.suggested_presentation_delay_seconds = input;
            self
        }
        /// Consumes the builder and constructs a [`DashPlaylistSettings`](crate::model::DashPlaylistSettings)
        pub fn build(self) -> crate::model::DashPlaylistSettings {
            crate::model::DashPlaylistSettings {
                manifest_window_seconds: self.manifest_window_seconds.unwrap_or_default(),
                min_buffer_time_seconds: self.min_buffer_time_seconds.unwrap_or_default(),
                min_update_period_seconds: self.min_update_period_seconds.unwrap_or_default(),
                suggested_presentation_delay_seconds: self
                    .suggested_presentation_delay_seconds
                    .unwrap_or_default(),
            }
        }
    }
}
impl DashPlaylistSettings {
    /// Creates a new builder-style object to manufacture [`DashPlaylistSettings`](crate::model::DashPlaylistSettings)
    pub fn builder() -> crate::model::dash_playlist_settings::Builder {
        crate::model::dash_playlist_settings::Builder::default()
    }
}

/// <p>Slate VOD source configuration.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SlateSource {
    /// <p>The name of the source location where the slate VOD source is stored.</p>
    pub source_location_name: std::option::Option<std::string::String>,
    /// <p>The slate VOD source name. The VOD source must already exist in a source location before it can be used for slate.</p>
    pub vod_source_name: std::option::Option<std::string::String>,
}
impl SlateSource {
    /// <p>The name of the source location where the slate VOD source is stored.</p>
    pub fn source_location_name(&self) -> std::option::Option<&str> {
        self.source_location_name.as_deref()
    }
    /// <p>The slate VOD source name. The VOD source must already exist in a source location before it can be used for slate.</p>
    pub fn vod_source_name(&self) -> std::option::Option<&str> {
        self.vod_source_name.as_deref()
    }
}
impl std::fmt::Debug for SlateSource {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SlateSource");
        formatter.field("source_location_name", &self.source_location_name);
        formatter.field("vod_source_name", &self.vod_source_name);
        formatter.finish()
    }
}
/// See [`SlateSource`](crate::model::SlateSource)
pub mod slate_source {
    /// A builder for [`SlateSource`](crate::model::SlateSource)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) source_location_name: std::option::Option<std::string::String>,
        pub(crate) vod_source_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The name of the source location where the slate VOD source is stored.</p>
        pub fn source_location_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_location_name = Some(input.into());
            self
        }
        /// <p>The name of the source location where the slate VOD source is stored.</p>
        pub fn set_source_location_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_location_name = input;
            self
        }
        /// <p>The slate VOD source name. The VOD source must already exist in a source location before it can be used for slate.</p>
        pub fn vod_source_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.vod_source_name = Some(input.into());
            self
        }
        /// <p>The slate VOD source name. The VOD source must already exist in a source location before it can be used for slate.</p>
        pub fn set_vod_source_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vod_source_name = input;
            self
        }
        /// Consumes the builder and constructs a [`SlateSource`](crate::model::SlateSource)
        pub fn build(self) -> crate::model::SlateSource {
            crate::model::SlateSource {
                source_location_name: self.source_location_name,
                vod_source_name: self.vod_source_name,
            }
        }
    }
}
impl SlateSource {
    /// Creates a new builder-style object to manufacture [`SlateSource`](crate::model::SlateSource)
    pub fn builder() -> crate::model::slate_source::Builder {
        crate::model::slate_source::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum ChannelState {
    #[allow(missing_docs)] // documentation missing in model
    Running,
    #[allow(missing_docs)] // documentation missing in model
    Stopped,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for ChannelState {
    fn from(s: &str) -> Self {
        match s {
            "RUNNING" => ChannelState::Running,
            "STOPPED" => ChannelState::Stopped,
            other => ChannelState::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for ChannelState {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(ChannelState::from(s))
    }
}
impl ChannelState {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            ChannelState::Running => "RUNNING",
            ChannelState::Stopped => "STOPPED",
            ChannelState::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["RUNNING", "STOPPED"]
    }
}
impl AsRef<str> for ChannelState {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>The output configuration for this channel.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct RequestOutputItem {
    /// <p>DASH manifest configuration parameters.</p>
    pub dash_playlist_settings: std::option::Option<crate::model::DashPlaylistSettings>,
    /// <p>HLS playlist configuration parameters.</p>
    pub hls_playlist_settings: std::option::Option<crate::model::HlsPlaylistSettings>,
    /// <p>The name of the manifest for the channel. The name appears in the PlaybackUrl.</p>
    pub manifest_name: std::option::Option<std::string::String>,
    /// <p>A string used to match which HttpPackageConfiguration is used for each VodSource.</p>
    pub source_group: std::option::Option<std::string::String>,
}
impl RequestOutputItem {
    /// <p>DASH manifest configuration parameters.</p>
    pub fn dash_playlist_settings(
        &self,
    ) -> std::option::Option<&crate::model::DashPlaylistSettings> {
        self.dash_playlist_settings.as_ref()
    }
    /// <p>HLS playlist configuration parameters.</p>
    pub fn hls_playlist_settings(&self) -> std::option::Option<&crate::model::HlsPlaylistSettings> {
        self.hls_playlist_settings.as_ref()
    }
    /// <p>The name of the manifest for the channel. The name appears in the PlaybackUrl.</p>
    pub fn manifest_name(&self) -> std::option::Option<&str> {
        self.manifest_name.as_deref()
    }
    /// <p>A string used to match which HttpPackageConfiguration is used for each VodSource.</p>
    pub fn source_group(&self) -> std::option::Option<&str> {
        self.source_group.as_deref()
    }
}
impl std::fmt::Debug for RequestOutputItem {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("RequestOutputItem");
        formatter.field("dash_playlist_settings", &self.dash_playlist_settings);
        formatter.field("hls_playlist_settings", &self.hls_playlist_settings);
        formatter.field("manifest_name", &self.manifest_name);
        formatter.field("source_group", &self.source_group);
        formatter.finish()
    }
}
/// See [`RequestOutputItem`](crate::model::RequestOutputItem)
pub mod request_output_item {
    /// A builder for [`RequestOutputItem`](crate::model::RequestOutputItem)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dash_playlist_settings: std::option::Option<crate::model::DashPlaylistSettings>,
        pub(crate) hls_playlist_settings: std::option::Option<crate::model::HlsPlaylistSettings>,
        pub(crate) manifest_name: std::option::Option<std::string::String>,
        pub(crate) source_group: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>DASH manifest configuration parameters.</p>
        pub fn dash_playlist_settings(mut self, input: crate::model::DashPlaylistSettings) -> Self {
            self.dash_playlist_settings = Some(input);
            self
        }
        /// <p>DASH manifest configuration parameters.</p>
        pub fn set_dash_playlist_settings(
            mut self,
            input: std::option::Option<crate::model::DashPlaylistSettings>,
        ) -> Self {
            self.dash_playlist_settings = input;
            self
        }
        /// <p>HLS playlist configuration parameters.</p>
        pub fn hls_playlist_settings(mut self, input: crate::model::HlsPlaylistSettings) -> Self {
            self.hls_playlist_settings = Some(input);
            self
        }
        /// <p>HLS playlist configuration parameters.</p>
        pub fn set_hls_playlist_settings(
            mut self,
            input: std::option::Option<crate::model::HlsPlaylistSettings>,
        ) -> Self {
            self.hls_playlist_settings = input;
            self
        }
        /// <p>The name of the manifest for the channel. The name appears in the PlaybackUrl.</p>
        pub fn manifest_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.manifest_name = Some(input.into());
            self
        }
        /// <p>The name of the manifest for the channel. The name appears in the PlaybackUrl.</p>
        pub fn set_manifest_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.manifest_name = input;
            self
        }
        /// <p>A string used to match which HttpPackageConfiguration is used for each VodSource.</p>
        pub fn source_group(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_group = Some(input.into());
            self
        }
        /// <p>A string used to match which HttpPackageConfiguration is used for each VodSource.</p>
        pub fn set_source_group(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.source_group = input;
            self
        }
        /// Consumes the builder and constructs a [`RequestOutputItem`](crate::model::RequestOutputItem)
        pub fn build(self) -> crate::model::RequestOutputItem {
            crate::model::RequestOutputItem {
                dash_playlist_settings: self.dash_playlist_settings,
                hls_playlist_settings: self.hls_playlist_settings,
                manifest_name: self.manifest_name,
                source_group: self.source_group,
            }
        }
    }
}
impl RequestOutputItem {
    /// Creates a new builder-style object to manufacture [`RequestOutputItem`](crate::model::RequestOutputItem)
    pub fn builder() -> crate::model::request_output_item::Builder {
        crate::model::request_output_item::Builder::default()
    }
}

/// <p>The configuration for manifest processing rules. Manifest processing rules enable customization of the personalized manifests created by MediaTailor.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ManifestProcessingRules {
    /// <p>For HLS, when set to true, MediaTailor passes through EXT-X-CUE-IN, EXT-X-CUE-OUT, and EXT-X-SPLICEPOINT-SCTE35 ad markers from the origin manifest to the MediaTailor personalized manifest.</p> <p>No logic is applied to these ad markers. For example, if EXT-X-CUE-OUT has a value of 60, but no ads are filled for that ad break, MediaTailor will not set the value to 0.</p>
    pub ad_marker_passthrough: std::option::Option<crate::model::AdMarkerPassthrough>,
}
impl ManifestProcessingRules {
    /// <p>For HLS, when set to true, MediaTailor passes through EXT-X-CUE-IN, EXT-X-CUE-OUT, and EXT-X-SPLICEPOINT-SCTE35 ad markers from the origin manifest to the MediaTailor personalized manifest.</p> <p>No logic is applied to these ad markers. For example, if EXT-X-CUE-OUT has a value of 60, but no ads are filled for that ad break, MediaTailor will not set the value to 0.</p>
    pub fn ad_marker_passthrough(&self) -> std::option::Option<&crate::model::AdMarkerPassthrough> {
        self.ad_marker_passthrough.as_ref()
    }
}
impl std::fmt::Debug for ManifestProcessingRules {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ManifestProcessingRules");
        formatter.field("ad_marker_passthrough", &self.ad_marker_passthrough);
        formatter.finish()
    }
}
/// See [`ManifestProcessingRules`](crate::model::ManifestProcessingRules)
pub mod manifest_processing_rules {
    /// A builder for [`ManifestProcessingRules`](crate::model::ManifestProcessingRules)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ad_marker_passthrough: std::option::Option<crate::model::AdMarkerPassthrough>,
    }
    impl Builder {
        /// <p>For HLS, when set to true, MediaTailor passes through EXT-X-CUE-IN, EXT-X-CUE-OUT, and EXT-X-SPLICEPOINT-SCTE35 ad markers from the origin manifest to the MediaTailor personalized manifest.</p> <p>No logic is applied to these ad markers. For example, if EXT-X-CUE-OUT has a value of 60, but no ads are filled for that ad break, MediaTailor will not set the value to 0.</p>
        pub fn ad_marker_passthrough(mut self, input: crate::model::AdMarkerPassthrough) -> Self {
            self.ad_marker_passthrough = Some(input);
            self
        }
        /// <p>For HLS, when set to true, MediaTailor passes through EXT-X-CUE-IN, EXT-X-CUE-OUT, and EXT-X-SPLICEPOINT-SCTE35 ad markers from the origin manifest to the MediaTailor personalized manifest.</p> <p>No logic is applied to these ad markers. For example, if EXT-X-CUE-OUT has a value of 60, but no ads are filled for that ad break, MediaTailor will not set the value to 0.</p>
        pub fn set_ad_marker_passthrough(
            mut self,
            input: std::option::Option<crate::model::AdMarkerPassthrough>,
        ) -> Self {
            self.ad_marker_passthrough = input;
            self
        }
        /// Consumes the builder and constructs a [`ManifestProcessingRules`](crate::model::ManifestProcessingRules)
        pub fn build(self) -> crate::model::ManifestProcessingRules {
            crate::model::ManifestProcessingRules {
                ad_marker_passthrough: self.ad_marker_passthrough,
            }
        }
    }
}
impl ManifestProcessingRules {
    /// Creates a new builder-style object to manufacture [`ManifestProcessingRules`](crate::model::ManifestProcessingRules)
    pub fn builder() -> crate::model::manifest_processing_rules::Builder {
        crate::model::manifest_processing_rules::Builder::default()
    }
}

/// <p>For HLS, when set to true, MediaTailor passes through EXT-X-CUE-IN, EXT-X-CUE-OUT, and EXT-X-SPLICEPOINT-SCTE35 ad markers from the origin manifest to the MediaTailor personalized manifest.</p> <p>No logic is applied to these ad markers. For example, if EXT-X-CUE-OUT has a value of 60, but no ads are filled for that ad break, MediaTailor will not set the value to 0.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AdMarkerPassthrough {
    /// <p>Enables ad marker passthrough for your configuration.</p>
    pub enabled: bool,
}
impl AdMarkerPassthrough {
    /// <p>Enables ad marker passthrough for your configuration.</p>
    pub fn enabled(&self) -> bool {
        self.enabled
    }
}
impl std::fmt::Debug for AdMarkerPassthrough {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AdMarkerPassthrough");
        formatter.field("enabled", &self.enabled);
        formatter.finish()
    }
}
/// See [`AdMarkerPassthrough`](crate::model::AdMarkerPassthrough)
pub mod ad_marker_passthrough {
    /// A builder for [`AdMarkerPassthrough`](crate::model::AdMarkerPassthrough)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) enabled: std::option::Option<bool>,
    }
    impl Builder {
        /// <p>Enables ad marker passthrough for your configuration.</p>
        pub fn enabled(mut self, input: bool) -> Self {
            self.enabled = Some(input);
            self
        }
        /// <p>Enables ad marker passthrough for your configuration.</p>
        pub fn set_enabled(mut self, input: std::option::Option<bool>) -> Self {
            self.enabled = input;
            self
        }
        /// Consumes the builder and constructs a [`AdMarkerPassthrough`](crate::model::AdMarkerPassthrough)
        pub fn build(self) -> crate::model::AdMarkerPassthrough {
            crate::model::AdMarkerPassthrough {
                enabled: self.enabled.unwrap_or_default(),
            }
        }
    }
}
impl AdMarkerPassthrough {
    /// Creates a new builder-style object to manufacture [`AdMarkerPassthrough`](crate::model::AdMarkerPassthrough)
    pub fn builder() -> crate::model::ad_marker_passthrough::Builder {
        crate::model::ad_marker_passthrough::Builder::default()
    }
}

/// <p>Returns Amazon CloudWatch log settings for a playback configuration.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct LogConfiguration {
    /// <p>The percentage of session logs that MediaTailor sends to your Cloudwatch Logs account. For example, if your playback configuration has 1000 sessions and percentEnabled is set to 60, MediaTailor sends logs for 600 of the sessions to CloudWatch Logs. MediaTailor decides at random which of the playback configuration sessions to send logs for. If you want to view logs for a specific session, you can use the <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/debug-log-mode.html">debug log mode</a>.</p> <p>Valid values: 0 - 100</p>
    pub percent_enabled: i32,
}
impl LogConfiguration {
    /// <p>The percentage of session logs that MediaTailor sends to your Cloudwatch Logs account. For example, if your playback configuration has 1000 sessions and percentEnabled is set to 60, MediaTailor sends logs for 600 of the sessions to CloudWatch Logs. MediaTailor decides at random which of the playback configuration sessions to send logs for. If you want to view logs for a specific session, you can use the <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/debug-log-mode.html">debug log mode</a>.</p> <p>Valid values: 0 - 100</p>
    pub fn percent_enabled(&self) -> i32 {
        self.percent_enabled
    }
}
impl std::fmt::Debug for LogConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("LogConfiguration");
        formatter.field("percent_enabled", &self.percent_enabled);
        formatter.finish()
    }
}
/// See [`LogConfiguration`](crate::model::LogConfiguration)
pub mod log_configuration {
    /// A builder for [`LogConfiguration`](crate::model::LogConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) percent_enabled: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The percentage of session logs that MediaTailor sends to your Cloudwatch Logs account. For example, if your playback configuration has 1000 sessions and percentEnabled is set to 60, MediaTailor sends logs for 600 of the sessions to CloudWatch Logs. MediaTailor decides at random which of the playback configuration sessions to send logs for. If you want to view logs for a specific session, you can use the <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/debug-log-mode.html">debug log mode</a>.</p> <p>Valid values: 0 - 100</p>
        pub fn percent_enabled(mut self, input: i32) -> Self {
            self.percent_enabled = Some(input);
            self
        }
        /// <p>The percentage of session logs that MediaTailor sends to your Cloudwatch Logs account. For example, if your playback configuration has 1000 sessions and percentEnabled is set to 60, MediaTailor sends logs for 600 of the sessions to CloudWatch Logs. MediaTailor decides at random which of the playback configuration sessions to send logs for. If you want to view logs for a specific session, you can use the <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/debug-log-mode.html">debug log mode</a>.</p> <p>Valid values: 0 - 100</p>
        pub fn set_percent_enabled(mut self, input: std::option::Option<i32>) -> Self {
            self.percent_enabled = input;
            self
        }
        /// Consumes the builder and constructs a [`LogConfiguration`](crate::model::LogConfiguration)
        pub fn build(self) -> crate::model::LogConfiguration {
            crate::model::LogConfiguration {
                percent_enabled: self.percent_enabled.unwrap_or_default(),
            }
        }
    }
}
impl LogConfiguration {
    /// Creates a new builder-style object to manufacture [`LogConfiguration`](crate::model::LogConfiguration)
    pub fn builder() -> crate::model::log_configuration::Builder {
        crate::model::log_configuration::Builder::default()
    }
}

/// <p>The configuration for pre-roll ad insertion.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct LivePreRollConfiguration {
    /// <p>The URL for the ad decision server (ADS) for pre-roll ads. This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing, you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
    pub ad_decision_server_url: std::option::Option<std::string::String>,
    /// The maximum allowed duration for the pre-roll ad avail. AWS Elemental MediaTailor won't play pre-roll ads to exceed this duration, regardless of the total duration of ads that the ADS returns.
    pub max_duration_seconds: i32,
}
impl LivePreRollConfiguration {
    /// <p>The URL for the ad decision server (ADS) for pre-roll ads. This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing, you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
    pub fn ad_decision_server_url(&self) -> std::option::Option<&str> {
        self.ad_decision_server_url.as_deref()
    }
    /// The maximum allowed duration for the pre-roll ad avail. AWS Elemental MediaTailor won't play pre-roll ads to exceed this duration, regardless of the total duration of ads that the ADS returns.
    pub fn max_duration_seconds(&self) -> i32 {
        self.max_duration_seconds
    }
}
impl std::fmt::Debug for LivePreRollConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("LivePreRollConfiguration");
        formatter.field("ad_decision_server_url", &self.ad_decision_server_url);
        formatter.field("max_duration_seconds", &self.max_duration_seconds);
        formatter.finish()
    }
}
/// See [`LivePreRollConfiguration`](crate::model::LivePreRollConfiguration)
pub mod live_pre_roll_configuration {
    /// A builder for [`LivePreRollConfiguration`](crate::model::LivePreRollConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ad_decision_server_url: std::option::Option<std::string::String>,
        pub(crate) max_duration_seconds: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>The URL for the ad decision server (ADS) for pre-roll ads. This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing, you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
        pub fn ad_decision_server_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.ad_decision_server_url = Some(input.into());
            self
        }
        /// <p>The URL for the ad decision server (ADS) for pre-roll ads. This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing, you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
        pub fn set_ad_decision_server_url(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ad_decision_server_url = input;
            self
        }
        /// The maximum allowed duration for the pre-roll ad avail. AWS Elemental MediaTailor won't play pre-roll ads to exceed this duration, regardless of the total duration of ads that the ADS returns.
        pub fn max_duration_seconds(mut self, input: i32) -> Self {
            self.max_duration_seconds = Some(input);
            self
        }
        /// The maximum allowed duration for the pre-roll ad avail. AWS Elemental MediaTailor won't play pre-roll ads to exceed this duration, regardless of the total duration of ads that the ADS returns.
        pub fn set_max_duration_seconds(mut self, input: std::option::Option<i32>) -> Self {
            self.max_duration_seconds = input;
            self
        }
        /// Consumes the builder and constructs a [`LivePreRollConfiguration`](crate::model::LivePreRollConfiguration)
        pub fn build(self) -> crate::model::LivePreRollConfiguration {
            crate::model::LivePreRollConfiguration {
                ad_decision_server_url: self.ad_decision_server_url,
                max_duration_seconds: self.max_duration_seconds.unwrap_or_default(),
            }
        }
    }
}
impl LivePreRollConfiguration {
    /// Creates a new builder-style object to manufacture [`LivePreRollConfiguration`](crate::model::LivePreRollConfiguration)
    pub fn builder() -> crate::model::live_pre_roll_configuration::Builder {
        crate::model::live_pre_roll_configuration::Builder::default()
    }
}

/// <p>The configuration for HLS content.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct HlsConfiguration {
    /// <p>The URL that is used to initiate a playback session for devices that support Apple HLS. The session uses server-side reporting.</p>
    pub manifest_endpoint_prefix: std::option::Option<std::string::String>,
}
impl HlsConfiguration {
    /// <p>The URL that is used to initiate a playback session for devices that support Apple HLS. The session uses server-side reporting.</p>
    pub fn manifest_endpoint_prefix(&self) -> std::option::Option<&str> {
        self.manifest_endpoint_prefix.as_deref()
    }
}
impl std::fmt::Debug for HlsConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("HlsConfiguration");
        formatter.field("manifest_endpoint_prefix", &self.manifest_endpoint_prefix);
        formatter.finish()
    }
}
/// See [`HlsConfiguration`](crate::model::HlsConfiguration)
pub mod hls_configuration {
    /// A builder for [`HlsConfiguration`](crate::model::HlsConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) manifest_endpoint_prefix: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The URL that is used to initiate a playback session for devices that support Apple HLS. The session uses server-side reporting.</p>
        pub fn manifest_endpoint_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.manifest_endpoint_prefix = Some(input.into());
            self
        }
        /// <p>The URL that is used to initiate a playback session for devices that support Apple HLS. The session uses server-side reporting.</p>
        pub fn set_manifest_endpoint_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.manifest_endpoint_prefix = input;
            self
        }
        /// Consumes the builder and constructs a [`HlsConfiguration`](crate::model::HlsConfiguration)
        pub fn build(self) -> crate::model::HlsConfiguration {
            crate::model::HlsConfiguration {
                manifest_endpoint_prefix: self.manifest_endpoint_prefix,
            }
        }
    }
}
impl HlsConfiguration {
    /// Creates a new builder-style object to manufacture [`HlsConfiguration`](crate::model::HlsConfiguration)
    pub fn builder() -> crate::model::hls_configuration::Builder {
        crate::model::hls_configuration::Builder::default()
    }
}

/// <p>The configuration for DASH content.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DashConfiguration {
    /// <p>The URL generated by MediaTailor to initiate a playback session. The session uses server-side reporting. This setting is ignored in PUT operations.</p>
    pub manifest_endpoint_prefix: std::option::Option<std::string::String>,
    /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
    pub mpd_location: std::option::Option<std::string::String>,
    /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
    pub origin_manifest_type: std::option::Option<crate::model::OriginManifestType>,
}
impl DashConfiguration {
    /// <p>The URL generated by MediaTailor to initiate a playback session. The session uses server-side reporting. This setting is ignored in PUT operations.</p>
    pub fn manifest_endpoint_prefix(&self) -> std::option::Option<&str> {
        self.manifest_endpoint_prefix.as_deref()
    }
    /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
    pub fn mpd_location(&self) -> std::option::Option<&str> {
        self.mpd_location.as_deref()
    }
    /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
    pub fn origin_manifest_type(&self) -> std::option::Option<&crate::model::OriginManifestType> {
        self.origin_manifest_type.as_ref()
    }
}
impl std::fmt::Debug for DashConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DashConfiguration");
        formatter.field("manifest_endpoint_prefix", &self.manifest_endpoint_prefix);
        formatter.field("mpd_location", &self.mpd_location);
        formatter.field("origin_manifest_type", &self.origin_manifest_type);
        formatter.finish()
    }
}
/// See [`DashConfiguration`](crate::model::DashConfiguration)
pub mod dash_configuration {
    /// A builder for [`DashConfiguration`](crate::model::DashConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) manifest_endpoint_prefix: std::option::Option<std::string::String>,
        pub(crate) mpd_location: std::option::Option<std::string::String>,
        pub(crate) origin_manifest_type: std::option::Option<crate::model::OriginManifestType>,
    }
    impl Builder {
        /// <p>The URL generated by MediaTailor to initiate a playback session. The session uses server-side reporting. This setting is ignored in PUT operations.</p>
        pub fn manifest_endpoint_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.manifest_endpoint_prefix = Some(input.into());
            self
        }
        /// <p>The URL generated by MediaTailor to initiate a playback session. The session uses server-side reporting. This setting is ignored in PUT operations.</p>
        pub fn set_manifest_endpoint_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.manifest_endpoint_prefix = input;
            self
        }
        /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
        pub fn mpd_location(mut self, input: impl Into<std::string::String>) -> Self {
            self.mpd_location = Some(input.into());
            self
        }
        /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
        pub fn set_mpd_location(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.mpd_location = input;
            self
        }
        /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
        pub fn origin_manifest_type(mut self, input: crate::model::OriginManifestType) -> Self {
            self.origin_manifest_type = Some(input);
            self
        }
        /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
        pub fn set_origin_manifest_type(
            mut self,
            input: std::option::Option<crate::model::OriginManifestType>,
        ) -> Self {
            self.origin_manifest_type = input;
            self
        }
        /// Consumes the builder and constructs a [`DashConfiguration`](crate::model::DashConfiguration)
        pub fn build(self) -> crate::model::DashConfiguration {
            crate::model::DashConfiguration {
                manifest_endpoint_prefix: self.manifest_endpoint_prefix,
                mpd_location: self.mpd_location,
                origin_manifest_type: self.origin_manifest_type,
            }
        }
    }
}
impl DashConfiguration {
    /// Creates a new builder-style object to manufacture [`DashConfiguration`](crate::model::DashConfiguration)
    pub fn builder() -> crate::model::dash_configuration::Builder {
        crate::model::dash_configuration::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum OriginManifestType {
    #[allow(missing_docs)] // documentation missing in model
    MultiPeriod,
    #[allow(missing_docs)] // documentation missing in model
    SinglePeriod,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for OriginManifestType {
    fn from(s: &str) -> Self {
        match s {
            "MULTI_PERIOD" => OriginManifestType::MultiPeriod,
            "SINGLE_PERIOD" => OriginManifestType::SinglePeriod,
            other => OriginManifestType::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for OriginManifestType {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(OriginManifestType::from(s))
    }
}
impl OriginManifestType {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            OriginManifestType::MultiPeriod => "MULTI_PERIOD",
            OriginManifestType::SinglePeriod => "SINGLE_PERIOD",
            OriginManifestType::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["MULTI_PERIOD", "SINGLE_PERIOD"]
    }
}
impl AsRef<str> for OriginManifestType {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>The configuration for using a content delivery network (CDN), like Amazon CloudFront, for content and ad segment management.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct CdnConfiguration {
    /// <p>A non-default content delivery network (CDN) to serve ad segments. By default, AWS Elemental MediaTailor uses Amazon CloudFront with default cache settings as its CDN for ad segments. To set up an alternate CDN, create a rule in your CDN for the origin ads.mediatailor.&amp;lt;region&gt;.amazonaws.com. Then specify the rule's name in this AdSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for ad segments.</p>
    pub ad_segment_url_prefix: std::option::Option<std::string::String>,
    /// <p>A content delivery network (CDN) to cache content segments, so that content requests don’t always have to go to the origin server. First, create a rule in your CDN for the content segment origin server. Then specify the rule's name in this ContentSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for content segments.</p>
    pub content_segment_url_prefix: std::option::Option<std::string::String>,
}
impl CdnConfiguration {
    /// <p>A non-default content delivery network (CDN) to serve ad segments. By default, AWS Elemental MediaTailor uses Amazon CloudFront with default cache settings as its CDN for ad segments. To set up an alternate CDN, create a rule in your CDN for the origin ads.mediatailor.&amp;lt;region&gt;.amazonaws.com. Then specify the rule's name in this AdSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for ad segments.</p>
    pub fn ad_segment_url_prefix(&self) -> std::option::Option<&str> {
        self.ad_segment_url_prefix.as_deref()
    }
    /// <p>A content delivery network (CDN) to cache content segments, so that content requests don’t always have to go to the origin server. First, create a rule in your CDN for the content segment origin server. Then specify the rule's name in this ContentSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for content segments.</p>
    pub fn content_segment_url_prefix(&self) -> std::option::Option<&str> {
        self.content_segment_url_prefix.as_deref()
    }
}
impl std::fmt::Debug for CdnConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("CdnConfiguration");
        formatter.field("ad_segment_url_prefix", &self.ad_segment_url_prefix);
        formatter.field(
            "content_segment_url_prefix",
            &self.content_segment_url_prefix,
        );
        formatter.finish()
    }
}
/// See [`CdnConfiguration`](crate::model::CdnConfiguration)
pub mod cdn_configuration {
    /// A builder for [`CdnConfiguration`](crate::model::CdnConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ad_segment_url_prefix: std::option::Option<std::string::String>,
        pub(crate) content_segment_url_prefix: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>A non-default content delivery network (CDN) to serve ad segments. By default, AWS Elemental MediaTailor uses Amazon CloudFront with default cache settings as its CDN for ad segments. To set up an alternate CDN, create a rule in your CDN for the origin ads.mediatailor.&amp;lt;region&gt;.amazonaws.com. Then specify the rule's name in this AdSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for ad segments.</p>
        pub fn ad_segment_url_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.ad_segment_url_prefix = Some(input.into());
            self
        }
        /// <p>A non-default content delivery network (CDN) to serve ad segments. By default, AWS Elemental MediaTailor uses Amazon CloudFront with default cache settings as its CDN for ad segments. To set up an alternate CDN, create a rule in your CDN for the origin ads.mediatailor.&amp;lt;region&gt;.amazonaws.com. Then specify the rule's name in this AdSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for ad segments.</p>
        pub fn set_ad_segment_url_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ad_segment_url_prefix = input;
            self
        }
        /// <p>A content delivery network (CDN) to cache content segments, so that content requests don’t always have to go to the origin server. First, create a rule in your CDN for the content segment origin server. Then specify the rule's name in this ContentSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for content segments.</p>
        pub fn content_segment_url_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.content_segment_url_prefix = Some(input.into());
            self
        }
        /// <p>A content delivery network (CDN) to cache content segments, so that content requests don’t always have to go to the origin server. First, create a rule in your CDN for the content segment origin server. Then specify the rule's name in this ContentSegmentUrlPrefix. When AWS Elemental MediaTailor serves a manifest, it reports your CDN as the source for content segments.</p>
        pub fn set_content_segment_url_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.content_segment_url_prefix = input;
            self
        }
        /// Consumes the builder and constructs a [`CdnConfiguration`](crate::model::CdnConfiguration)
        pub fn build(self) -> crate::model::CdnConfiguration {
            crate::model::CdnConfiguration {
                ad_segment_url_prefix: self.ad_segment_url_prefix,
                content_segment_url_prefix: self.content_segment_url_prefix,
            }
        }
    }
}
impl CdnConfiguration {
    /// Creates a new builder-style object to manufacture [`CdnConfiguration`](crate::model::CdnConfiguration)
    pub fn builder() -> crate::model::cdn_configuration::Builder {
        crate::model::cdn_configuration::Builder::default()
    }
}

/// <p>The configuration for bumpers. Bumpers are short audio or video clips that play at the start or before the end of an ad break. To learn more about bumpers, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/bumpers.html">Bumpers</a>.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct Bumper {
    /// <p>The URL for the end bumper asset.</p>
    pub end_url: std::option::Option<std::string::String>,
    /// <p>The URL for the start bumper asset.</p>
    pub start_url: std::option::Option<std::string::String>,
}
impl Bumper {
    /// <p>The URL for the end bumper asset.</p>
    pub fn end_url(&self) -> std::option::Option<&str> {
        self.end_url.as_deref()
    }
    /// <p>The URL for the start bumper asset.</p>
    pub fn start_url(&self) -> std::option::Option<&str> {
        self.start_url.as_deref()
    }
}
impl std::fmt::Debug for Bumper {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("Bumper");
        formatter.field("end_url", &self.end_url);
        formatter.field("start_url", &self.start_url);
        formatter.finish()
    }
}
/// See [`Bumper`](crate::model::Bumper)
pub mod bumper {
    /// A builder for [`Bumper`](crate::model::Bumper)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) end_url: std::option::Option<std::string::String>,
        pub(crate) start_url: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The URL for the end bumper asset.</p>
        pub fn end_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.end_url = Some(input.into());
            self
        }
        /// <p>The URL for the end bumper asset.</p>
        pub fn set_end_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.end_url = input;
            self
        }
        /// <p>The URL for the start bumper asset.</p>
        pub fn start_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.start_url = Some(input.into());
            self
        }
        /// <p>The URL for the start bumper asset.</p>
        pub fn set_start_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.start_url = input;
            self
        }
        /// Consumes the builder and constructs a [`Bumper`](crate::model::Bumper)
        pub fn build(self) -> crate::model::Bumper {
            crate::model::Bumper {
                end_url: self.end_url,
                start_url: self.start_url,
            }
        }
    }
}
impl Bumper {
    /// Creates a new builder-style object to manufacture [`Bumper`](crate::model::Bumper)
    pub fn builder() -> crate::model::bumper::Builder {
        crate::model::bumper::Builder::default()
    }
}

/// <p>The configuration for avail suppression, also known as ad suppression. For more information about ad suppression, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Suppression</a>.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AvailSuppression {
    /// <p>Sets the ad suppression mode. By default, ad suppression is off and all ad breaks are filled with ads or slate. When Mode is set to BEHIND_LIVE_EDGE, ad suppression is active and MediaTailor won't fill ad breaks on or behind the ad suppression Value time in the manifest lookback window.</p>
    pub mode: std::option::Option<crate::model::Mode>,
    /// <p>A live edge offset time in HH:MM:SS. MediaTailor won't fill ad breaks on or behind this time in the manifest lookback window. If Value is set to 00:00:00, it is in sync with the live edge, and MediaTailor won't fill any ad breaks on or behind the live edge. If you set a Value time, MediaTailor won't fill any ad breaks on or behind this time in the manifest lookback window. For example, if you set 00:45:00, then MediaTailor will fill ad breaks that occur within 45 minutes behind the live edge, but won't fill ad breaks on or behind 45 minutes behind the live edge.</p>
    pub value: std::option::Option<std::string::String>,
}
impl AvailSuppression {
    /// <p>Sets the ad suppression mode. By default, ad suppression is off and all ad breaks are filled with ads or slate. When Mode is set to BEHIND_LIVE_EDGE, ad suppression is active and MediaTailor won't fill ad breaks on or behind the ad suppression Value time in the manifest lookback window.</p>
    pub fn mode(&self) -> std::option::Option<&crate::model::Mode> {
        self.mode.as_ref()
    }
    /// <p>A live edge offset time in HH:MM:SS. MediaTailor won't fill ad breaks on or behind this time in the manifest lookback window. If Value is set to 00:00:00, it is in sync with the live edge, and MediaTailor won't fill any ad breaks on or behind the live edge. If you set a Value time, MediaTailor won't fill any ad breaks on or behind this time in the manifest lookback window. For example, if you set 00:45:00, then MediaTailor will fill ad breaks that occur within 45 minutes behind the live edge, but won't fill ad breaks on or behind 45 minutes behind the live edge.</p>
    pub fn value(&self) -> std::option::Option<&str> {
        self.value.as_deref()
    }
}
impl std::fmt::Debug for AvailSuppression {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AvailSuppression");
        formatter.field("mode", &self.mode);
        formatter.field("value", &self.value);
        formatter.finish()
    }
}
/// See [`AvailSuppression`](crate::model::AvailSuppression)
pub mod avail_suppression {
    /// A builder for [`AvailSuppression`](crate::model::AvailSuppression)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) mode: std::option::Option<crate::model::Mode>,
        pub(crate) value: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>Sets the ad suppression mode. By default, ad suppression is off and all ad breaks are filled with ads or slate. When Mode is set to BEHIND_LIVE_EDGE, ad suppression is active and MediaTailor won't fill ad breaks on or behind the ad suppression Value time in the manifest lookback window.</p>
        pub fn mode(mut self, input: crate::model::Mode) -> Self {
            self.mode = Some(input);
            self
        }
        /// <p>Sets the ad suppression mode. By default, ad suppression is off and all ad breaks are filled with ads or slate. When Mode is set to BEHIND_LIVE_EDGE, ad suppression is active and MediaTailor won't fill ad breaks on or behind the ad suppression Value time in the manifest lookback window.</p>
        pub fn set_mode(mut self, input: std::option::Option<crate::model::Mode>) -> Self {
            self.mode = input;
            self
        }
        /// <p>A live edge offset time in HH:MM:SS. MediaTailor won't fill ad breaks on or behind this time in the manifest lookback window. If Value is set to 00:00:00, it is in sync with the live edge, and MediaTailor won't fill any ad breaks on or behind the live edge. If you set a Value time, MediaTailor won't fill any ad breaks on or behind this time in the manifest lookback window. For example, if you set 00:45:00, then MediaTailor will fill ad breaks that occur within 45 minutes behind the live edge, but won't fill ad breaks on or behind 45 minutes behind the live edge.</p>
        pub fn value(mut self, input: impl Into<std::string::String>) -> Self {
            self.value = Some(input.into());
            self
        }
        /// <p>A live edge offset time in HH:MM:SS. MediaTailor won't fill ad breaks on or behind this time in the manifest lookback window. If Value is set to 00:00:00, it is in sync with the live edge, and MediaTailor won't fill any ad breaks on or behind the live edge. If you set a Value time, MediaTailor won't fill any ad breaks on or behind this time in the manifest lookback window. For example, if you set 00:45:00, then MediaTailor will fill ad breaks that occur within 45 minutes behind the live edge, but won't fill ad breaks on or behind 45 minutes behind the live edge.</p>
        pub fn set_value(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.value = input;
            self
        }
        /// Consumes the builder and constructs a [`AvailSuppression`](crate::model::AvailSuppression)
        pub fn build(self) -> crate::model::AvailSuppression {
            crate::model::AvailSuppression {
                mode: self.mode,
                value: self.value,
            }
        }
    }
}
impl AvailSuppression {
    /// Creates a new builder-style object to manufacture [`AvailSuppression`](crate::model::AvailSuppression)
    pub fn builder() -> crate::model::avail_suppression::Builder {
        crate::model::avail_suppression::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum Mode {
    #[allow(missing_docs)] // documentation missing in model
    BehindLiveEdge,
    #[allow(missing_docs)] // documentation missing in model
    Off,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for Mode {
    fn from(s: &str) -> Self {
        match s {
            "BEHIND_LIVE_EDGE" => Mode::BehindLiveEdge,
            "OFF" => Mode::Off,
            other => Mode::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for Mode {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(Mode::from(s))
    }
}
impl Mode {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            Mode::BehindLiveEdge => "BEHIND_LIVE_EDGE",
            Mode::Off => "OFF",
            Mode::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["BEHIND_LIVE_EDGE", "OFF"]
    }
}
impl AsRef<str> for Mode {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>The configuration for DASH PUT operations.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct DashConfigurationForPut {
    /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
    pub mpd_location: std::option::Option<std::string::String>,
    /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
    pub origin_manifest_type: std::option::Option<crate::model::OriginManifestType>,
}
impl DashConfigurationForPut {
    /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
    pub fn mpd_location(&self) -> std::option::Option<&str> {
        self.mpd_location.as_deref()
    }
    /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
    pub fn origin_manifest_type(&self) -> std::option::Option<&crate::model::OriginManifestType> {
        self.origin_manifest_type.as_ref()
    }
}
impl std::fmt::Debug for DashConfigurationForPut {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("DashConfigurationForPut");
        formatter.field("mpd_location", &self.mpd_location);
        formatter.field("origin_manifest_type", &self.origin_manifest_type);
        formatter.finish()
    }
}
/// See [`DashConfigurationForPut`](crate::model::DashConfigurationForPut)
pub mod dash_configuration_for_put {
    /// A builder for [`DashConfigurationForPut`](crate::model::DashConfigurationForPut)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) mpd_location: std::option::Option<std::string::String>,
        pub(crate) origin_manifest_type: std::option::Option<crate::model::OriginManifestType>,
    }
    impl Builder {
        /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
        pub fn mpd_location(mut self, input: impl Into<std::string::String>) -> Self {
            self.mpd_location = Some(input.into());
            self
        }
        /// <p>The setting that controls whether MediaTailor includes the Location tag in DASH manifests. MediaTailor populates the Location tag with the URL for manifest update requests, to be used by players that don't support sticky redirects. Disable this if you have CDN routing rules set up for accessing MediaTailor manifests, and you are either using client-side reporting or your players support sticky HTTP redirects. Valid values are DISABLED and EMT_DEFAULT. The EMT_DEFAULT setting enables the inclusion of the tag and is the default value.</p>
        pub fn set_mpd_location(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.mpd_location = input;
            self
        }
        /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
        pub fn origin_manifest_type(mut self, input: crate::model::OriginManifestType) -> Self {
            self.origin_manifest_type = Some(input);
            self
        }
        /// <p>The setting that controls whether MediaTailor handles manifests from the origin server as multi-period manifests or single-period manifests. If your origin server produces single-period manifests, set this to SINGLE_PERIOD. The default setting is MULTI_PERIOD. For multi-period manifests, omit this setting or set it to MULTI_PERIOD.</p>
        pub fn set_origin_manifest_type(
            mut self,
            input: std::option::Option<crate::model::OriginManifestType>,
        ) -> Self {
            self.origin_manifest_type = input;
            self
        }
        /// Consumes the builder and constructs a [`DashConfigurationForPut`](crate::model::DashConfigurationForPut)
        pub fn build(self) -> crate::model::DashConfigurationForPut {
            crate::model::DashConfigurationForPut {
                mpd_location: self.mpd_location,
                origin_manifest_type: self.origin_manifest_type,
            }
        }
    }
}
impl DashConfigurationForPut {
    /// Creates a new builder-style object to manufacture [`DashConfigurationForPut`](crate::model::DashConfigurationForPut)
    pub fn builder() -> crate::model::dash_configuration_for_put::Builder {
        crate::model::dash_configuration_for_put::Builder::default()
    }
}

/// <p>VOD source configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct VodSource {
    /// <p>The ARN for the VOD source.</p>
    pub arn: std::option::Option<std::string::String>,
    /// <p>The timestamp that indicates when the VOD source was created.</p>
    pub creation_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The HTTP package configurations for the VOD source.</p>
    pub http_package_configurations:
        std::option::Option<std::vec::Vec<crate::model::HttpPackageConfiguration>>,
    /// <p>The timestamp that indicates when the VOD source was last modified.</p>
    pub last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The name of the source location that the VOD source is associated with.</p>
    pub source_location_name: std::option::Option<std::string::String>,
    /// <p>The tags assigned to the VOD source.</p>
    pub tags:
        std::option::Option<std::collections::HashMap<std::string::String, std::string::String>>,
    /// <p>The name of the VOD source.</p>
    pub vod_source_name: std::option::Option<std::string::String>,
}
impl VodSource {
    /// <p>The ARN for the VOD source.</p>
    pub fn arn(&self) -> std::option::Option<&str> {
        self.arn.as_deref()
    }
    /// <p>The timestamp that indicates when the VOD source was created.</p>
    pub fn creation_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.creation_time.as_ref()
    }
    /// <p>The HTTP package configurations for the VOD source.</p>
    pub fn http_package_configurations(
        &self,
    ) -> std::option::Option<&[crate::model::HttpPackageConfiguration]> {
        self.http_package_configurations.as_deref()
    }
    /// <p>The timestamp that indicates when the VOD source was last modified.</p>
    pub fn last_modified_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.last_modified_time.as_ref()
    }
    /// <p>The name of the source location that the VOD source is associated with.</p>
    pub fn source_location_name(&self) -> std::option::Option<&str> {
        self.source_location_name.as_deref()
    }
    /// <p>The tags assigned to the VOD source.</p>
    pub fn tags(
        &self,
    ) -> std::option::Option<&std::collections::HashMap<std::string::String, std::string::String>>
    {
        self.tags.as_ref()
    }
    /// <p>The name of the VOD source.</p>
    pub fn vod_source_name(&self) -> std::option::Option<&str> {
        self.vod_source_name.as_deref()
    }
}
impl std::fmt::Debug for VodSource {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("VodSource");
        formatter.field("arn", &self.arn);
        formatter.field("creation_time", &self.creation_time);
        formatter.field(
            "http_package_configurations",
            &self.http_package_configurations,
        );
        formatter.field("last_modified_time", &self.last_modified_time);
        formatter.field("source_location_name", &self.source_location_name);
        formatter.field("tags", &self.tags);
        formatter.field("vod_source_name", &self.vod_source_name);
        formatter.finish()
    }
}
/// See [`VodSource`](crate::model::VodSource)
pub mod vod_source {
    /// A builder for [`VodSource`](crate::model::VodSource)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) arn: std::option::Option<std::string::String>,
        pub(crate) creation_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) http_package_configurations:
            std::option::Option<std::vec::Vec<crate::model::HttpPackageConfiguration>>,
        pub(crate) last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) source_location_name: std::option::Option<std::string::String>,
        pub(crate) tags: std::option::Option<
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
        pub(crate) vod_source_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The ARN for the VOD source.</p>
        pub fn arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.arn = Some(input.into());
            self
        }
        /// <p>The ARN for the VOD source.</p>
        pub fn set_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.arn = input;
            self
        }
        /// <p>The timestamp that indicates when the VOD source was created.</p>
        pub fn creation_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.creation_time = Some(input);
            self
        }
        /// <p>The timestamp that indicates when the VOD source was created.</p>
        pub fn set_creation_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.creation_time = input;
            self
        }
        /// Appends an item to `http_package_configurations`.
        ///
        /// To override the contents of this collection use [`set_http_package_configurations`](Self::set_http_package_configurations).
        ///
        /// <p>The HTTP package configurations for the VOD source.</p>
        pub fn http_package_configurations(
            mut self,
            input: impl Into<crate::model::HttpPackageConfiguration>,
        ) -> Self {
            let mut v = self.http_package_configurations.unwrap_or_default();
            v.push(input.into());
            self.http_package_configurations = Some(v);
            self
        }
        /// <p>The HTTP package configurations for the VOD source.</p>
        pub fn set_http_package_configurations(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::HttpPackageConfiguration>>,
        ) -> Self {
            self.http_package_configurations = input;
            self
        }
        /// <p>The timestamp that indicates when the VOD source was last modified.</p>
        pub fn last_modified_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.last_modified_time = Some(input);
            self
        }
        /// <p>The timestamp that indicates when the VOD source was last modified.</p>
        pub fn set_last_modified_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.last_modified_time = input;
            self
        }
        /// <p>The name of the source location that the VOD source is associated with.</p>
        pub fn source_location_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_location_name = Some(input.into());
            self
        }
        /// <p>The name of the source location that the VOD source is associated with.</p>
        pub fn set_source_location_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_location_name = input;
            self
        }
        /// Adds a key-value pair to `tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>The tags assigned to the VOD source.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            let mut hash_map = self.tags.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.tags = Some(hash_map);
            self
        }
        /// <p>The tags assigned to the VOD source.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.tags = input;
            self
        }
        /// <p>The name of the VOD source.</p>
        pub fn vod_source_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.vod_source_name = Some(input.into());
            self
        }
        /// <p>The name of the VOD source.</p>
        pub fn set_vod_source_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vod_source_name = input;
            self
        }
        /// Consumes the builder and constructs a [`VodSource`](crate::model::VodSource)
        pub fn build(self) -> crate::model::VodSource {
            crate::model::VodSource {
                arn: self.arn,
                creation_time: self.creation_time,
                http_package_configurations: self.http_package_configurations,
                last_modified_time: self.last_modified_time,
                source_location_name: self.source_location_name,
                tags: self.tags,
                vod_source_name: self.vod_source_name,
            }
        }
    }
}
impl VodSource {
    /// Creates a new builder-style object to manufacture [`VodSource`](crate::model::VodSource)
    pub fn builder() -> crate::model::vod_source::Builder {
        crate::model::vod_source::Builder::default()
    }
}

/// <p>This response includes only the "type" : "object" property.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SourceLocation {
    /// <p>The access configuration for the source location.</p>
    pub access_configuration: std::option::Option<crate::model::AccessConfiguration>,
    /// <p>The ARN of the SourceLocation.</p>
    pub arn: std::option::Option<std::string::String>,
    /// <p>The timestamp that indicates when the source location was created.</p>
    pub creation_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The default segment delivery configuration.</p>
    pub default_segment_delivery_configuration:
        std::option::Option<crate::model::DefaultSegmentDeliveryConfiguration>,
    /// <p>The HTTP configuration for the source location.</p>
    pub http_configuration: std::option::Option<crate::model::HttpConfiguration>,
    /// <p>The timestamp that indicates when the source location was last modified.</p>
    pub last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The name of the source location.</p>
    pub source_location_name: std::option::Option<std::string::String>,
    /// <p>The tags assigned to the source location.</p>
    pub tags:
        std::option::Option<std::collections::HashMap<std::string::String, std::string::String>>,
}
impl SourceLocation {
    /// <p>The access configuration for the source location.</p>
    pub fn access_configuration(&self) -> std::option::Option<&crate::model::AccessConfiguration> {
        self.access_configuration.as_ref()
    }
    /// <p>The ARN of the SourceLocation.</p>
    pub fn arn(&self) -> std::option::Option<&str> {
        self.arn.as_deref()
    }
    /// <p>The timestamp that indicates when the source location was created.</p>
    pub fn creation_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.creation_time.as_ref()
    }
    /// <p>The default segment delivery configuration.</p>
    pub fn default_segment_delivery_configuration(
        &self,
    ) -> std::option::Option<&crate::model::DefaultSegmentDeliveryConfiguration> {
        self.default_segment_delivery_configuration.as_ref()
    }
    /// <p>The HTTP configuration for the source location.</p>
    pub fn http_configuration(&self) -> std::option::Option<&crate::model::HttpConfiguration> {
        self.http_configuration.as_ref()
    }
    /// <p>The timestamp that indicates when the source location was last modified.</p>
    pub fn last_modified_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.last_modified_time.as_ref()
    }
    /// <p>The name of the source location.</p>
    pub fn source_location_name(&self) -> std::option::Option<&str> {
        self.source_location_name.as_deref()
    }
    /// <p>The tags assigned to the source location.</p>
    pub fn tags(
        &self,
    ) -> std::option::Option<&std::collections::HashMap<std::string::String, std::string::String>>
    {
        self.tags.as_ref()
    }
}
impl std::fmt::Debug for SourceLocation {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SourceLocation");
        formatter.field("access_configuration", &self.access_configuration);
        formatter.field("arn", &self.arn);
        formatter.field("creation_time", &self.creation_time);
        formatter.field(
            "default_segment_delivery_configuration",
            &self.default_segment_delivery_configuration,
        );
        formatter.field("http_configuration", &self.http_configuration);
        formatter.field("last_modified_time", &self.last_modified_time);
        formatter.field("source_location_name", &self.source_location_name);
        formatter.field("tags", &self.tags);
        formatter.finish()
    }
}
/// See [`SourceLocation`](crate::model::SourceLocation)
pub mod source_location {
    /// A builder for [`SourceLocation`](crate::model::SourceLocation)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) access_configuration: std::option::Option<crate::model::AccessConfiguration>,
        pub(crate) arn: std::option::Option<std::string::String>,
        pub(crate) creation_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) default_segment_delivery_configuration:
            std::option::Option<crate::model::DefaultSegmentDeliveryConfiguration>,
        pub(crate) http_configuration: std::option::Option<crate::model::HttpConfiguration>,
        pub(crate) last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) source_location_name: std::option::Option<std::string::String>,
        pub(crate) tags: std::option::Option<
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
    }
    impl Builder {
        /// <p>The access configuration for the source location.</p>
        pub fn access_configuration(mut self, input: crate::model::AccessConfiguration) -> Self {
            self.access_configuration = Some(input);
            self
        }
        /// <p>The access configuration for the source location.</p>
        pub fn set_access_configuration(
            mut self,
            input: std::option::Option<crate::model::AccessConfiguration>,
        ) -> Self {
            self.access_configuration = input;
            self
        }
        /// <p>The ARN of the SourceLocation.</p>
        pub fn arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.arn = Some(input.into());
            self
        }
        /// <p>The ARN of the SourceLocation.</p>
        pub fn set_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.arn = input;
            self
        }
        /// <p>The timestamp that indicates when the source location was created.</p>
        pub fn creation_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.creation_time = Some(input);
            self
        }
        /// <p>The timestamp that indicates when the source location was created.</p>
        pub fn set_creation_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.creation_time = input;
            self
        }
        /// <p>The default segment delivery configuration.</p>
        pub fn default_segment_delivery_configuration(
            mut self,
            input: crate::model::DefaultSegmentDeliveryConfiguration,
        ) -> Self {
            self.default_segment_delivery_configuration = Some(input);
            self
        }
        /// <p>The default segment delivery configuration.</p>
        pub fn set_default_segment_delivery_configuration(
            mut self,
            input: std::option::Option<crate::model::DefaultSegmentDeliveryConfiguration>,
        ) -> Self {
            self.default_segment_delivery_configuration = input;
            self
        }
        /// <p>The HTTP configuration for the source location.</p>
        pub fn http_configuration(mut self, input: crate::model::HttpConfiguration) -> Self {
            self.http_configuration = Some(input);
            self
        }
        /// <p>The HTTP configuration for the source location.</p>
        pub fn set_http_configuration(
            mut self,
            input: std::option::Option<crate::model::HttpConfiguration>,
        ) -> Self {
            self.http_configuration = input;
            self
        }
        /// <p>The timestamp that indicates when the source location was last modified.</p>
        pub fn last_modified_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.last_modified_time = Some(input);
            self
        }
        /// <p>The timestamp that indicates when the source location was last modified.</p>
        pub fn set_last_modified_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.last_modified_time = input;
            self
        }
        /// <p>The name of the source location.</p>
        pub fn source_location_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_location_name = Some(input.into());
            self
        }
        /// <p>The name of the source location.</p>
        pub fn set_source_location_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_location_name = input;
            self
        }
        /// Adds a key-value pair to `tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>The tags assigned to the source location.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            let mut hash_map = self.tags.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.tags = Some(hash_map);
            self
        }
        /// <p>The tags assigned to the source location.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.tags = input;
            self
        }
        /// Consumes the builder and constructs a [`SourceLocation`](crate::model::SourceLocation)
        pub fn build(self) -> crate::model::SourceLocation {
            crate::model::SourceLocation {
                access_configuration: self.access_configuration,
                arn: self.arn,
                creation_time: self.creation_time,
                default_segment_delivery_configuration: self.default_segment_delivery_configuration,
                http_configuration: self.http_configuration,
                last_modified_time: self.last_modified_time,
                source_location_name: self.source_location_name,
                tags: self.tags,
            }
        }
    }
}
impl SourceLocation {
    /// Creates a new builder-style object to manufacture [`SourceLocation`](crate::model::SourceLocation)
    pub fn builder() -> crate::model::source_location::Builder {
        crate::model::source_location::Builder::default()
    }
}

/// <p>A complex type that contains prefetch schedule information.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PrefetchSchedule {
    /// <p>The Amazon Resource Name (ARN) of the prefetch schedule.</p>
    pub arn: std::option::Option<std::string::String>,
    /// <p>Consumption settings determine how, and when, MediaTailor places the prefetched ads into ad breaks. Ad consumption occurs within a span of time that you define, called a <i>consumption window</i>. You can designate which ad breaks that MediaTailor fills with prefetch ads by setting avail matching criteria.</p>
    pub consumption: std::option::Option<crate::model::PrefetchConsumption>,
    /// <p>The name of the prefetch schedule. The name must be unique among all prefetch schedules that are associated with the specified playback configuration.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>The name of the playback configuration to create the prefetch schedule for.</p>
    pub playback_configuration_name: std::option::Option<std::string::String>,
    /// <p>A complex type that contains settings for prefetch retrieval from the ad decision server (ADS).</p>
    pub retrieval: std::option::Option<crate::model::PrefetchRetrieval>,
    /// <p>An optional stream identifier that you can specify in order to prefetch for multiple streams that use the same playback configuration.</p>
    pub stream_id: std::option::Option<std::string::String>,
}
impl PrefetchSchedule {
    /// <p>The Amazon Resource Name (ARN) of the prefetch schedule.</p>
    pub fn arn(&self) -> std::option::Option<&str> {
        self.arn.as_deref()
    }
    /// <p>Consumption settings determine how, and when, MediaTailor places the prefetched ads into ad breaks. Ad consumption occurs within a span of time that you define, called a <i>consumption window</i>. You can designate which ad breaks that MediaTailor fills with prefetch ads by setting avail matching criteria.</p>
    pub fn consumption(&self) -> std::option::Option<&crate::model::PrefetchConsumption> {
        self.consumption.as_ref()
    }
    /// <p>The name of the prefetch schedule. The name must be unique among all prefetch schedules that are associated with the specified playback configuration.</p>
    pub fn name(&self) -> std::option::Option<&str> {
        self.name.as_deref()
    }
    /// <p>The name of the playback configuration to create the prefetch schedule for.</p>
    pub fn playback_configuration_name(&self) -> std::option::Option<&str> {
        self.playback_configuration_name.as_deref()
    }
    /// <p>A complex type that contains settings for prefetch retrieval from the ad decision server (ADS).</p>
    pub fn retrieval(&self) -> std::option::Option<&crate::model::PrefetchRetrieval> {
        self.retrieval.as_ref()
    }
    /// <p>An optional stream identifier that you can specify in order to prefetch for multiple streams that use the same playback configuration.</p>
    pub fn stream_id(&self) -> std::option::Option<&str> {
        self.stream_id.as_deref()
    }
}
impl std::fmt::Debug for PrefetchSchedule {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PrefetchSchedule");
        formatter.field("arn", &self.arn);
        formatter.field("consumption", &self.consumption);
        formatter.field("name", &self.name);
        formatter.field(
            "playback_configuration_name",
            &self.playback_configuration_name,
        );
        formatter.field("retrieval", &self.retrieval);
        formatter.field("stream_id", &self.stream_id);
        formatter.finish()
    }
}
/// See [`PrefetchSchedule`](crate::model::PrefetchSchedule)
pub mod prefetch_schedule {
    /// A builder for [`PrefetchSchedule`](crate::model::PrefetchSchedule)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) arn: std::option::Option<std::string::String>,
        pub(crate) consumption: std::option::Option<crate::model::PrefetchConsumption>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) playback_configuration_name: std::option::Option<std::string::String>,
        pub(crate) retrieval: std::option::Option<crate::model::PrefetchRetrieval>,
        pub(crate) stream_id: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The Amazon Resource Name (ARN) of the prefetch schedule.</p>
        pub fn arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.arn = Some(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the prefetch schedule.</p>
        pub fn set_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.arn = input;
            self
        }
        /// <p>Consumption settings determine how, and when, MediaTailor places the prefetched ads into ad breaks. Ad consumption occurs within a span of time that you define, called a <i>consumption window</i>. You can designate which ad breaks that MediaTailor fills with prefetch ads by setting avail matching criteria.</p>
        pub fn consumption(mut self, input: crate::model::PrefetchConsumption) -> Self {
            self.consumption = Some(input);
            self
        }
        /// <p>Consumption settings determine how, and when, MediaTailor places the prefetched ads into ad breaks. Ad consumption occurs within a span of time that you define, called a <i>consumption window</i>. You can designate which ad breaks that MediaTailor fills with prefetch ads by setting avail matching criteria.</p>
        pub fn set_consumption(
            mut self,
            input: std::option::Option<crate::model::PrefetchConsumption>,
        ) -> Self {
            self.consumption = input;
            self
        }
        /// <p>The name of the prefetch schedule. The name must be unique among all prefetch schedules that are associated with the specified playback configuration.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        /// <p>The name of the prefetch schedule. The name must be unique among all prefetch schedules that are associated with the specified playback configuration.</p>
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>The name of the playback configuration to create the prefetch schedule for.</p>
        pub fn playback_configuration_name(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.playback_configuration_name = Some(input.into());
            self
        }
        /// <p>The name of the playback configuration to create the prefetch schedule for.</p>
        pub fn set_playback_configuration_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.playback_configuration_name = input;
            self
        }
        /// <p>A complex type that contains settings for prefetch retrieval from the ad decision server (ADS).</p>
        pub fn retrieval(mut self, input: crate::model::PrefetchRetrieval) -> Self {
            self.retrieval = Some(input);
            self
        }
        /// <p>A complex type that contains settings for prefetch retrieval from the ad decision server (ADS).</p>
        pub fn set_retrieval(
            mut self,
            input: std::option::Option<crate::model::PrefetchRetrieval>,
        ) -> Self {
            self.retrieval = input;
            self
        }
        /// <p>An optional stream identifier that you can specify in order to prefetch for multiple streams that use the same playback configuration.</p>
        pub fn stream_id(mut self, input: impl Into<std::string::String>) -> Self {
            self.stream_id = Some(input.into());
            self
        }
        /// <p>An optional stream identifier that you can specify in order to prefetch for multiple streams that use the same playback configuration.</p>
        pub fn set_stream_id(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.stream_id = input;
            self
        }
        /// Consumes the builder and constructs a [`PrefetchSchedule`](crate::model::PrefetchSchedule)
        pub fn build(self) -> crate::model::PrefetchSchedule {
            crate::model::PrefetchSchedule {
                arn: self.arn,
                consumption: self.consumption,
                name: self.name,
                playback_configuration_name: self.playback_configuration_name,
                retrieval: self.retrieval,
                stream_id: self.stream_id,
            }
        }
    }
}
impl PrefetchSchedule {
    /// Creates a new builder-style object to manufacture [`PrefetchSchedule`](crate::model::PrefetchSchedule)
    pub fn builder() -> crate::model::prefetch_schedule::Builder {
        crate::model::prefetch_schedule::Builder::default()
    }
}

/// <p>A complex type that contains settings governing when MediaTailor prefetches ads, and which dynamic variables that MediaTailor includes in the request to the ad decision server.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PrefetchRetrieval {
    /// <p>The dynamic variables to use for substitution during prefetch requests to the ad decision server (ADS).</p> <p>You intially configure <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">dynamic variables</a> for the ADS URL when you set up your playback configuration. When you specify DynamicVariables for prefetch retrieval, MediaTailor includes the dynamic variables in the request to the ADS.</p>
    pub dynamic_variables:
        std::option::Option<std::collections::HashMap<std::string::String, std::string::String>>,
    /// <p>The time when prefetch retrieval ends for the ad break. Prefetching will be attempted for manifest requests that occur at or before this time.</p>
    pub end_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The time when prefetch retrievals can start for this break. Ad prefetching will be attempted for manifest requests that occur at or after this time. Defaults to the current time. If not specified, the prefetch retrieval starts as soon as possible.</p>
    pub start_time: std::option::Option<aws_smithy_types::DateTime>,
}
impl PrefetchRetrieval {
    /// <p>The dynamic variables to use for substitution during prefetch requests to the ad decision server (ADS).</p> <p>You intially configure <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">dynamic variables</a> for the ADS URL when you set up your playback configuration. When you specify DynamicVariables for prefetch retrieval, MediaTailor includes the dynamic variables in the request to the ADS.</p>
    pub fn dynamic_variables(
        &self,
    ) -> std::option::Option<&std::collections::HashMap<std::string::String, std::string::String>>
    {
        self.dynamic_variables.as_ref()
    }
    /// <p>The time when prefetch retrieval ends for the ad break. Prefetching will be attempted for manifest requests that occur at or before this time.</p>
    pub fn end_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.end_time.as_ref()
    }
    /// <p>The time when prefetch retrievals can start for this break. Ad prefetching will be attempted for manifest requests that occur at or after this time. Defaults to the current time. If not specified, the prefetch retrieval starts as soon as possible.</p>
    pub fn start_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.start_time.as_ref()
    }
}
impl std::fmt::Debug for PrefetchRetrieval {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PrefetchRetrieval");
        formatter.field("dynamic_variables", &self.dynamic_variables);
        formatter.field("end_time", &self.end_time);
        formatter.field("start_time", &self.start_time);
        formatter.finish()
    }
}
/// See [`PrefetchRetrieval`](crate::model::PrefetchRetrieval)
pub mod prefetch_retrieval {
    /// A builder for [`PrefetchRetrieval`](crate::model::PrefetchRetrieval)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dynamic_variables: std::option::Option<
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
        pub(crate) end_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) start_time: std::option::Option<aws_smithy_types::DateTime>,
    }
    impl Builder {
        /// Adds a key-value pair to `dynamic_variables`.
        ///
        /// To override the contents of this collection use [`set_dynamic_variables`](Self::set_dynamic_variables).
        ///
        /// <p>The dynamic variables to use for substitution during prefetch requests to the ad decision server (ADS).</p> <p>You intially configure <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">dynamic variables</a> for the ADS URL when you set up your playback configuration. When you specify DynamicVariables for prefetch retrieval, MediaTailor includes the dynamic variables in the request to the ADS.</p>
        pub fn dynamic_variables(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            let mut hash_map = self.dynamic_variables.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.dynamic_variables = Some(hash_map);
            self
        }
        /// <p>The dynamic variables to use for substitution during prefetch requests to the ad decision server (ADS).</p> <p>You intially configure <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">dynamic variables</a> for the ADS URL when you set up your playback configuration. When you specify DynamicVariables for prefetch retrieval, MediaTailor includes the dynamic variables in the request to the ADS.</p>
        pub fn set_dynamic_variables(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.dynamic_variables = input;
            self
        }
        /// <p>The time when prefetch retrieval ends for the ad break. Prefetching will be attempted for manifest requests that occur at or before this time.</p>
        pub fn end_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.end_time = Some(input);
            self
        }
        /// <p>The time when prefetch retrieval ends for the ad break. Prefetching will be attempted for manifest requests that occur at or before this time.</p>
        pub fn set_end_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.end_time = input;
            self
        }
        /// <p>The time when prefetch retrievals can start for this break. Ad prefetching will be attempted for manifest requests that occur at or after this time. Defaults to the current time. If not specified, the prefetch retrieval starts as soon as possible.</p>
        pub fn start_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.start_time = Some(input);
            self
        }
        /// <p>The time when prefetch retrievals can start for this break. Ad prefetching will be attempted for manifest requests that occur at or after this time. Defaults to the current time. If not specified, the prefetch retrieval starts as soon as possible.</p>
        pub fn set_start_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.start_time = input;
            self
        }
        /// Consumes the builder and constructs a [`PrefetchRetrieval`](crate::model::PrefetchRetrieval)
        pub fn build(self) -> crate::model::PrefetchRetrieval {
            crate::model::PrefetchRetrieval {
                dynamic_variables: self.dynamic_variables,
                end_time: self.end_time,
                start_time: self.start_time,
            }
        }
    }
}
impl PrefetchRetrieval {
    /// Creates a new builder-style object to manufacture [`PrefetchRetrieval`](crate::model::PrefetchRetrieval)
    pub fn builder() -> crate::model::prefetch_retrieval::Builder {
        crate::model::prefetch_retrieval::Builder::default()
    }
}

/// <p>A complex type that contains settings that determine how and when that MediaTailor places prefetched ads into upcoming ad breaks.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PrefetchConsumption {
    /// <p>If you only want MediaTailor to insert prefetched ads into avails (ad breaks) that match specific dynamic variables, such as scte.event_id, set the avail matching criteria.</p>
    pub avail_matching_criteria:
        std::option::Option<std::vec::Vec<crate::model::AvailMatchingCriteria>>,
    /// <p>The time when MediaTailor no longer considers the prefetched ads for use in an ad break. MediaTailor automatically deletes prefetch schedules no less than seven days after the end time. If you'd like to manually delete the prefetch schedule, you can call DeletePrefetchSchedule.</p>
    pub end_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The time when prefetched ads are considered for use in an ad break. If you don't specify StartTime, the prefetched ads are available after MediaTailor retrives them from the ad decision server.</p>
    pub start_time: std::option::Option<aws_smithy_types::DateTime>,
}
impl PrefetchConsumption {
    /// <p>If you only want MediaTailor to insert prefetched ads into avails (ad breaks) that match specific dynamic variables, such as scte.event_id, set the avail matching criteria.</p>
    pub fn avail_matching_criteria(
        &self,
    ) -> std::option::Option<&[crate::model::AvailMatchingCriteria]> {
        self.avail_matching_criteria.as_deref()
    }
    /// <p>The time when MediaTailor no longer considers the prefetched ads for use in an ad break. MediaTailor automatically deletes prefetch schedules no less than seven days after the end time. If you'd like to manually delete the prefetch schedule, you can call DeletePrefetchSchedule.</p>
    pub fn end_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.end_time.as_ref()
    }
    /// <p>The time when prefetched ads are considered for use in an ad break. If you don't specify StartTime, the prefetched ads are available after MediaTailor retrives them from the ad decision server.</p>
    pub fn start_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.start_time.as_ref()
    }
}
impl std::fmt::Debug for PrefetchConsumption {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PrefetchConsumption");
        formatter.field("avail_matching_criteria", &self.avail_matching_criteria);
        formatter.field("end_time", &self.end_time);
        formatter.field("start_time", &self.start_time);
        formatter.finish()
    }
}
/// See [`PrefetchConsumption`](crate::model::PrefetchConsumption)
pub mod prefetch_consumption {
    /// A builder for [`PrefetchConsumption`](crate::model::PrefetchConsumption)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) avail_matching_criteria:
            std::option::Option<std::vec::Vec<crate::model::AvailMatchingCriteria>>,
        pub(crate) end_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) start_time: std::option::Option<aws_smithy_types::DateTime>,
    }
    impl Builder {
        /// Appends an item to `avail_matching_criteria`.
        ///
        /// To override the contents of this collection use [`set_avail_matching_criteria`](Self::set_avail_matching_criteria).
        ///
        /// <p>If you only want MediaTailor to insert prefetched ads into avails (ad breaks) that match specific dynamic variables, such as scte.event_id, set the avail matching criteria.</p>
        pub fn avail_matching_criteria(
            mut self,
            input: impl Into<crate::model::AvailMatchingCriteria>,
        ) -> Self {
            let mut v = self.avail_matching_criteria.unwrap_or_default();
            v.push(input.into());
            self.avail_matching_criteria = Some(v);
            self
        }
        /// <p>If you only want MediaTailor to insert prefetched ads into avails (ad breaks) that match specific dynamic variables, such as scte.event_id, set the avail matching criteria.</p>
        pub fn set_avail_matching_criteria(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::AvailMatchingCriteria>>,
        ) -> Self {
            self.avail_matching_criteria = input;
            self
        }
        /// <p>The time when MediaTailor no longer considers the prefetched ads for use in an ad break. MediaTailor automatically deletes prefetch schedules no less than seven days after the end time. If you'd like to manually delete the prefetch schedule, you can call DeletePrefetchSchedule.</p>
        pub fn end_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.end_time = Some(input);
            self
        }
        /// <p>The time when MediaTailor no longer considers the prefetched ads for use in an ad break. MediaTailor automatically deletes prefetch schedules no less than seven days after the end time. If you'd like to manually delete the prefetch schedule, you can call DeletePrefetchSchedule.</p>
        pub fn set_end_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.end_time = input;
            self
        }
        /// <p>The time when prefetched ads are considered for use in an ad break. If you don't specify StartTime, the prefetched ads are available after MediaTailor retrives them from the ad decision server.</p>
        pub fn start_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.start_time = Some(input);
            self
        }
        /// <p>The time when prefetched ads are considered for use in an ad break. If you don't specify StartTime, the prefetched ads are available after MediaTailor retrives them from the ad decision server.</p>
        pub fn set_start_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.start_time = input;
            self
        }
        /// Consumes the builder and constructs a [`PrefetchConsumption`](crate::model::PrefetchConsumption)
        pub fn build(self) -> crate::model::PrefetchConsumption {
            crate::model::PrefetchConsumption {
                avail_matching_criteria: self.avail_matching_criteria,
                end_time: self.end_time,
                start_time: self.start_time,
            }
        }
    }
}
impl PrefetchConsumption {
    /// Creates a new builder-style object to manufacture [`PrefetchConsumption`](crate::model::PrefetchConsumption)
    pub fn builder() -> crate::model::prefetch_consumption::Builder {
        crate::model::prefetch_consumption::Builder::default()
    }
}

/// <p>MediaTailor only places (consumes) prefetched ads if the ad break meets the criteria defined by the dynamic variables. This gives you granular control over which ad break to place the prefetched ads into.</p> <p>As an example, let's say that you set DynamicVariable to scte.event_id and Operator to EQUALS, and your playback configuration has an ADS URL of https://my.ads.server.com/path?&amp;podId=[scte.avail_num]&amp;event=[scte.event_id]&amp;duration=[session.avail_duration_secs]. And the prefetch request to the ADS contains these values https://my.ads.server.com/path?&amp;podId=3&amp;event=my-awesome-event&amp;duration=30. MediaTailor will only insert the prefetched ads into the ad break if has a SCTE marker with an event id of my-awesome-event, since it must match the event id that MediaTailor uses to query the ADS.</p> <p>You can specify up to five AvailMatchingCriteria. If you specify multiple AvailMatchingCriteria, MediaTailor combines them to match using a logical AND. You can model logical OR combinations by creating multiple prefetch schedules.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AvailMatchingCriteria {
    /// <p>The dynamic variable(s) that MediaTailor should use as avail matching criteria. MediaTailor only places the prefetched ads into the avail if the avail matches the criteria defined by the dynamic variable. For information about dynamic variables, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">Using dynamic ad variables</a> in the <i>MediaTailor User Guide</i>.</p> <p>You can include up to 100 dynamic variables.</p>
    pub dynamic_variable: std::option::Option<std::string::String>,
    /// <p>For the DynamicVariable specified in AvailMatchingCriteria, the Operator that is used for the comparison.</p>
    pub operator: std::option::Option<crate::model::Operator>,
}
impl AvailMatchingCriteria {
    /// <p>The dynamic variable(s) that MediaTailor should use as avail matching criteria. MediaTailor only places the prefetched ads into the avail if the avail matches the criteria defined by the dynamic variable. For information about dynamic variables, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">Using dynamic ad variables</a> in the <i>MediaTailor User Guide</i>.</p> <p>You can include up to 100 dynamic variables.</p>
    pub fn dynamic_variable(&self) -> std::option::Option<&str> {
        self.dynamic_variable.as_deref()
    }
    /// <p>For the DynamicVariable specified in AvailMatchingCriteria, the Operator that is used for the comparison.</p>
    pub fn operator(&self) -> std::option::Option<&crate::model::Operator> {
        self.operator.as_ref()
    }
}
impl std::fmt::Debug for AvailMatchingCriteria {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AvailMatchingCriteria");
        formatter.field("dynamic_variable", &self.dynamic_variable);
        formatter.field("operator", &self.operator);
        formatter.finish()
    }
}
/// See [`AvailMatchingCriteria`](crate::model::AvailMatchingCriteria)
pub mod avail_matching_criteria {
    /// A builder for [`AvailMatchingCriteria`](crate::model::AvailMatchingCriteria)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) dynamic_variable: std::option::Option<std::string::String>,
        pub(crate) operator: std::option::Option<crate::model::Operator>,
    }
    impl Builder {
        /// <p>The dynamic variable(s) that MediaTailor should use as avail matching criteria. MediaTailor only places the prefetched ads into the avail if the avail matches the criteria defined by the dynamic variable. For information about dynamic variables, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">Using dynamic ad variables</a> in the <i>MediaTailor User Guide</i>.</p> <p>You can include up to 100 dynamic variables.</p>
        pub fn dynamic_variable(mut self, input: impl Into<std::string::String>) -> Self {
            self.dynamic_variable = Some(input.into());
            self
        }
        /// <p>The dynamic variable(s) that MediaTailor should use as avail matching criteria. MediaTailor only places the prefetched ads into the avail if the avail matches the criteria defined by the dynamic variable. For information about dynamic variables, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables.html">Using dynamic ad variables</a> in the <i>MediaTailor User Guide</i>.</p> <p>You can include up to 100 dynamic variables.</p>
        pub fn set_dynamic_variable(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.dynamic_variable = input;
            self
        }
        /// <p>For the DynamicVariable specified in AvailMatchingCriteria, the Operator that is used for the comparison.</p>
        pub fn operator(mut self, input: crate::model::Operator) -> Self {
            self.operator = Some(input);
            self
        }
        /// <p>For the DynamicVariable specified in AvailMatchingCriteria, the Operator that is used for the comparison.</p>
        pub fn set_operator(mut self, input: std::option::Option<crate::model::Operator>) -> Self {
            self.operator = input;
            self
        }
        /// Consumes the builder and constructs a [`AvailMatchingCriteria`](crate::model::AvailMatchingCriteria)
        pub fn build(self) -> crate::model::AvailMatchingCriteria {
            crate::model::AvailMatchingCriteria {
                dynamic_variable: self.dynamic_variable,
                operator: self.operator,
            }
        }
    }
}
impl AvailMatchingCriteria {
    /// Creates a new builder-style object to manufacture [`AvailMatchingCriteria`](crate::model::AvailMatchingCriteria)
    pub fn builder() -> crate::model::avail_matching_criteria::Builder {
        crate::model::avail_matching_criteria::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum Operator {
    #[allow(missing_docs)] // documentation missing in model
    Equals,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for Operator {
    fn from(s: &str) -> Self {
        match s {
            "EQUALS" => Operator::Equals,
            other => Operator::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for Operator {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(Operator::from(s))
    }
}
impl Operator {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            Operator::Equals => "EQUALS",
            Operator::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["EQUALS"]
    }
}
impl AsRef<str> for Operator {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>Creates a playback configuration. For information about MediaTailor configurations, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/configurations.html">Working with configurations in AWS Elemental MediaTailor</a>.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct PlaybackConfiguration {
    /// <p>The URL for the ad decision server (ADS). This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
    pub ad_decision_server_url: std::option::Option<std::string::String>,
    /// <p>The configuration for avail suppression, also known as ad suppression. For more information about ad suppression, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Suppression</a>.</p>
    pub avail_suppression: std::option::Option<crate::model::AvailSuppression>,
    /// <p>The configuration for bumpers. Bumpers are short audio or video clips that play at the start or before the end of an ad break. To learn more about bumpers, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/bumpers.html">Bumpers</a>.</p>
    pub bumper: std::option::Option<crate::model::Bumper>,
    /// <p>The configuration for using a content delivery network (CDN), like Amazon CloudFront, for content and ad segment management.</p>
    pub cdn_configuration: std::option::Option<crate::model::CdnConfiguration>,
    /// <p>The player parameters and aliases used as dynamic variables during session initialization. For more information, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables-domain.html">Domain Variables</a>.</p>
    pub configuration_aliases: std::option::Option<
        std::collections::HashMap<
            std::string::String,
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
    >,
    /// <p>The configuration for a DASH source.</p>
    pub dash_configuration: std::option::Option<crate::model::DashConfiguration>,
    /// <p>The configuration for HLS content.</p>
    pub hls_configuration: std::option::Option<crate::model::HlsConfiguration>,
    /// <p>The configuration for pre-roll ad insertion.</p>
    pub live_pre_roll_configuration: std::option::Option<crate::model::LivePreRollConfiguration>,
    /// <p>The Amazon CloudWatch log settings for a playback configuration.</p>
    pub log_configuration: std::option::Option<crate::model::LogConfiguration>,
    /// <p>The configuration for manifest processing rules. Manifest processing rules enable customization of the personalized manifests created by MediaTailor.</p>
    pub manifest_processing_rules: std::option::Option<crate::model::ManifestProcessingRules>,
    /// <p>The identifier for the playback configuration.</p>
    pub name: std::option::Option<std::string::String>,
    /// <p>Defines the maximum duration of underfilled ad time (in seconds) allowed in an ad break. If the duration of underfilled ad time exceeds the personalization threshold, then the personalization of the ad break is abandoned and the underlying content is shown. This feature applies to <i>ad replacement</i> in live and VOD streams, rather than ad insertion, because it relies on an underlying content stream. For more information about ad break behavior, including ad replacement and insertion, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Behavior in AWS Elemental MediaTailor</a>.</p>
    pub personalization_threshold_seconds: i32,
    /// <p>The Amazon Resource Name (ARN) for the playback configuration.</p>
    pub playback_configuration_arn: std::option::Option<std::string::String>,
    /// <p>The URL that the player accesses to get a manifest from AWS Elemental MediaTailor.</p>
    pub playback_endpoint_prefix: std::option::Option<std::string::String>,
    /// <p>The URL that the player uses to initialize a session that uses client-side reporting.</p>
    pub session_initialization_endpoint_prefix: std::option::Option<std::string::String>,
    /// <p>The URL for a video asset to transcode and use to fill in time that's not used by ads. AWS Elemental MediaTailor shows the slate to fill in gaps in media content. Configuring the slate is optional for non-VPAID playback configurations. For VPAID, the slate is required because MediaTailor provides it in the slots designated for dynamic ad content. The slate must be a high-quality asset that contains both audio and video.</p>
    pub slate_ad_url: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the playback configuration.</p>
    pub tags:
        std::option::Option<std::collections::HashMap<std::string::String, std::string::String>>,
    /// <p>The name that is used to associate this playback configuration with a custom transcode profile. This overrides the dynamic transcoding defaults of MediaTailor. Use this only if you have already set up custom profiles with the help of AWS Support.</p>
    pub transcode_profile_name: std::option::Option<std::string::String>,
    /// <p>The URL prefix for the parent manifest for the stream, minus the asset ID. The maximum length is 512 characters.</p>
    pub video_content_source_url: std::option::Option<std::string::String>,
}
impl PlaybackConfiguration {
    /// <p>The URL for the ad decision server (ADS). This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
    pub fn ad_decision_server_url(&self) -> std::option::Option<&str> {
        self.ad_decision_server_url.as_deref()
    }
    /// <p>The configuration for avail suppression, also known as ad suppression. For more information about ad suppression, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Suppression</a>.</p>
    pub fn avail_suppression(&self) -> std::option::Option<&crate::model::AvailSuppression> {
        self.avail_suppression.as_ref()
    }
    /// <p>The configuration for bumpers. Bumpers are short audio or video clips that play at the start or before the end of an ad break. To learn more about bumpers, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/bumpers.html">Bumpers</a>.</p>
    pub fn bumper(&self) -> std::option::Option<&crate::model::Bumper> {
        self.bumper.as_ref()
    }
    /// <p>The configuration for using a content delivery network (CDN), like Amazon CloudFront, for content and ad segment management.</p>
    pub fn cdn_configuration(&self) -> std::option::Option<&crate::model::CdnConfiguration> {
        self.cdn_configuration.as_ref()
    }
    /// <p>The player parameters and aliases used as dynamic variables during session initialization. For more information, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables-domain.html">Domain Variables</a>.</p>
    pub fn configuration_aliases(
        &self,
    ) -> std::option::Option<
        &std::collections::HashMap<
            std::string::String,
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
    > {
        self.configuration_aliases.as_ref()
    }
    /// <p>The configuration for a DASH source.</p>
    pub fn dash_configuration(&self) -> std::option::Option<&crate::model::DashConfiguration> {
        self.dash_configuration.as_ref()
    }
    /// <p>The configuration for HLS content.</p>
    pub fn hls_configuration(&self) -> std::option::Option<&crate::model::HlsConfiguration> {
        self.hls_configuration.as_ref()
    }
    /// <p>The configuration for pre-roll ad insertion.</p>
    pub fn live_pre_roll_configuration(
        &self,
    ) -> std::option::Option<&crate::model::LivePreRollConfiguration> {
        self.live_pre_roll_configuration.as_ref()
    }
    /// <p>The Amazon CloudWatch log settings for a playback configuration.</p>
    pub fn log_configuration(&self) -> std::option::Option<&crate::model::LogConfiguration> {
        self.log_configuration.as_ref()
    }
    /// <p>The configuration for manifest processing rules. Manifest processing rules enable customization of the personalized manifests created by MediaTailor.</p>
    pub fn manifest_processing_rules(
        &self,
    ) -> std::option::Option<&crate::model::ManifestProcessingRules> {
        self.manifest_processing_rules.as_ref()
    }
    /// <p>The identifier for the playback configuration.</p>
    pub fn name(&self) -> std::option::Option<&str> {
        self.name.as_deref()
    }
    /// <p>Defines the maximum duration of underfilled ad time (in seconds) allowed in an ad break. If the duration of underfilled ad time exceeds the personalization threshold, then the personalization of the ad break is abandoned and the underlying content is shown. This feature applies to <i>ad replacement</i> in live and VOD streams, rather than ad insertion, because it relies on an underlying content stream. For more information about ad break behavior, including ad replacement and insertion, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Behavior in AWS Elemental MediaTailor</a>.</p>
    pub fn personalization_threshold_seconds(&self) -> i32 {
        self.personalization_threshold_seconds
    }
    /// <p>The Amazon Resource Name (ARN) for the playback configuration.</p>
    pub fn playback_configuration_arn(&self) -> std::option::Option<&str> {
        self.playback_configuration_arn.as_deref()
    }
    /// <p>The URL that the player accesses to get a manifest from AWS Elemental MediaTailor.</p>
    pub fn playback_endpoint_prefix(&self) -> std::option::Option<&str> {
        self.playback_endpoint_prefix.as_deref()
    }
    /// <p>The URL that the player uses to initialize a session that uses client-side reporting.</p>
    pub fn session_initialization_endpoint_prefix(&self) -> std::option::Option<&str> {
        self.session_initialization_endpoint_prefix.as_deref()
    }
    /// <p>The URL for a video asset to transcode and use to fill in time that's not used by ads. AWS Elemental MediaTailor shows the slate to fill in gaps in media content. Configuring the slate is optional for non-VPAID playback configurations. For VPAID, the slate is required because MediaTailor provides it in the slots designated for dynamic ad content. The slate must be a high-quality asset that contains both audio and video.</p>
    pub fn slate_ad_url(&self) -> std::option::Option<&str> {
        self.slate_ad_url.as_deref()
    }
    /// <p>The tags to assign to the playback configuration.</p>
    pub fn tags(
        &self,
    ) -> std::option::Option<&std::collections::HashMap<std::string::String, std::string::String>>
    {
        self.tags.as_ref()
    }
    /// <p>The name that is used to associate this playback configuration with a custom transcode profile. This overrides the dynamic transcoding defaults of MediaTailor. Use this only if you have already set up custom profiles with the help of AWS Support.</p>
    pub fn transcode_profile_name(&self) -> std::option::Option<&str> {
        self.transcode_profile_name.as_deref()
    }
    /// <p>The URL prefix for the parent manifest for the stream, minus the asset ID. The maximum length is 512 characters.</p>
    pub fn video_content_source_url(&self) -> std::option::Option<&str> {
        self.video_content_source_url.as_deref()
    }
}
impl std::fmt::Debug for PlaybackConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("PlaybackConfiguration");
        formatter.field("ad_decision_server_url", &self.ad_decision_server_url);
        formatter.field("avail_suppression", &self.avail_suppression);
        formatter.field("bumper", &self.bumper);
        formatter.field("cdn_configuration", &self.cdn_configuration);
        formatter.field("configuration_aliases", &self.configuration_aliases);
        formatter.field("dash_configuration", &self.dash_configuration);
        formatter.field("hls_configuration", &self.hls_configuration);
        formatter.field(
            "live_pre_roll_configuration",
            &self.live_pre_roll_configuration,
        );
        formatter.field("log_configuration", &self.log_configuration);
        formatter.field("manifest_processing_rules", &self.manifest_processing_rules);
        formatter.field("name", &self.name);
        formatter.field(
            "personalization_threshold_seconds",
            &self.personalization_threshold_seconds,
        );
        formatter.field(
            "playback_configuration_arn",
            &self.playback_configuration_arn,
        );
        formatter.field("playback_endpoint_prefix", &self.playback_endpoint_prefix);
        formatter.field(
            "session_initialization_endpoint_prefix",
            &self.session_initialization_endpoint_prefix,
        );
        formatter.field("slate_ad_url", &self.slate_ad_url);
        formatter.field("tags", &self.tags);
        formatter.field("transcode_profile_name", &self.transcode_profile_name);
        formatter.field("video_content_source_url", &self.video_content_source_url);
        formatter.finish()
    }
}
/// See [`PlaybackConfiguration`](crate::model::PlaybackConfiguration)
pub mod playback_configuration {
    /// A builder for [`PlaybackConfiguration`](crate::model::PlaybackConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) ad_decision_server_url: std::option::Option<std::string::String>,
        pub(crate) avail_suppression: std::option::Option<crate::model::AvailSuppression>,
        pub(crate) bumper: std::option::Option<crate::model::Bumper>,
        pub(crate) cdn_configuration: std::option::Option<crate::model::CdnConfiguration>,
        pub(crate) configuration_aliases: std::option::Option<
            std::collections::HashMap<
                std::string::String,
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        >,
        pub(crate) dash_configuration: std::option::Option<crate::model::DashConfiguration>,
        pub(crate) hls_configuration: std::option::Option<crate::model::HlsConfiguration>,
        pub(crate) live_pre_roll_configuration:
            std::option::Option<crate::model::LivePreRollConfiguration>,
        pub(crate) log_configuration: std::option::Option<crate::model::LogConfiguration>,
        pub(crate) manifest_processing_rules:
            std::option::Option<crate::model::ManifestProcessingRules>,
        pub(crate) name: std::option::Option<std::string::String>,
        pub(crate) personalization_threshold_seconds: std::option::Option<i32>,
        pub(crate) playback_configuration_arn: std::option::Option<std::string::String>,
        pub(crate) playback_endpoint_prefix: std::option::Option<std::string::String>,
        pub(crate) session_initialization_endpoint_prefix: std::option::Option<std::string::String>,
        pub(crate) slate_ad_url: std::option::Option<std::string::String>,
        pub(crate) tags: std::option::Option<
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
        pub(crate) transcode_profile_name: std::option::Option<std::string::String>,
        pub(crate) video_content_source_url: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The URL for the ad decision server (ADS). This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
        pub fn ad_decision_server_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.ad_decision_server_url = Some(input.into());
            self
        }
        /// <p>The URL for the ad decision server (ADS). This includes the specification of static parameters and placeholders for dynamic parameters. AWS Elemental MediaTailor substitutes player-specific and session-specific parameters as needed when calling the ADS. Alternately, for testing you can provide a static VAST URL. The maximum length is 25,000 characters.</p>
        pub fn set_ad_decision_server_url(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.ad_decision_server_url = input;
            self
        }
        /// <p>The configuration for avail suppression, also known as ad suppression. For more information about ad suppression, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Suppression</a>.</p>
        pub fn avail_suppression(mut self, input: crate::model::AvailSuppression) -> Self {
            self.avail_suppression = Some(input);
            self
        }
        /// <p>The configuration for avail suppression, also known as ad suppression. For more information about ad suppression, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Suppression</a>.</p>
        pub fn set_avail_suppression(
            mut self,
            input: std::option::Option<crate::model::AvailSuppression>,
        ) -> Self {
            self.avail_suppression = input;
            self
        }
        /// <p>The configuration for bumpers. Bumpers are short audio or video clips that play at the start or before the end of an ad break. To learn more about bumpers, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/bumpers.html">Bumpers</a>.</p>
        pub fn bumper(mut self, input: crate::model::Bumper) -> Self {
            self.bumper = Some(input);
            self
        }
        /// <p>The configuration for bumpers. Bumpers are short audio or video clips that play at the start or before the end of an ad break. To learn more about bumpers, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/bumpers.html">Bumpers</a>.</p>
        pub fn set_bumper(mut self, input: std::option::Option<crate::model::Bumper>) -> Self {
            self.bumper = input;
            self
        }
        /// <p>The configuration for using a content delivery network (CDN), like Amazon CloudFront, for content and ad segment management.</p>
        pub fn cdn_configuration(mut self, input: crate::model::CdnConfiguration) -> Self {
            self.cdn_configuration = Some(input);
            self
        }
        /// <p>The configuration for using a content delivery network (CDN), like Amazon CloudFront, for content and ad segment management.</p>
        pub fn set_cdn_configuration(
            mut self,
            input: std::option::Option<crate::model::CdnConfiguration>,
        ) -> Self {
            self.cdn_configuration = input;
            self
        }
        /// Adds a key-value pair to `configuration_aliases`.
        ///
        /// To override the contents of this collection use [`set_configuration_aliases`](Self::set_configuration_aliases).
        ///
        /// <p>The player parameters and aliases used as dynamic variables during session initialization. For more information, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables-domain.html">Domain Variables</a>.</p>
        pub fn configuration_aliases(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::collections::HashMap<std::string::String, std::string::String>>,
        ) -> Self {
            let mut hash_map = self.configuration_aliases.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.configuration_aliases = Some(hash_map);
            self
        }
        /// <p>The player parameters and aliases used as dynamic variables during session initialization. For more information, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/variables-domain.html">Domain Variables</a>.</p>
        pub fn set_configuration_aliases(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<
                    std::string::String,
                    std::collections::HashMap<std::string::String, std::string::String>,
                >,
            >,
        ) -> Self {
            self.configuration_aliases = input;
            self
        }
        /// <p>The configuration for a DASH source.</p>
        pub fn dash_configuration(mut self, input: crate::model::DashConfiguration) -> Self {
            self.dash_configuration = Some(input);
            self
        }
        /// <p>The configuration for a DASH source.</p>
        pub fn set_dash_configuration(
            mut self,
            input: std::option::Option<crate::model::DashConfiguration>,
        ) -> Self {
            self.dash_configuration = input;
            self
        }
        /// <p>The configuration for HLS content.</p>
        pub fn hls_configuration(mut self, input: crate::model::HlsConfiguration) -> Self {
            self.hls_configuration = Some(input);
            self
        }
        /// <p>The configuration for HLS content.</p>
        pub fn set_hls_configuration(
            mut self,
            input: std::option::Option<crate::model::HlsConfiguration>,
        ) -> Self {
            self.hls_configuration = input;
            self
        }
        /// <p>The configuration for pre-roll ad insertion.</p>
        pub fn live_pre_roll_configuration(
            mut self,
            input: crate::model::LivePreRollConfiguration,
        ) -> Self {
            self.live_pre_roll_configuration = Some(input);
            self
        }
        /// <p>The configuration for pre-roll ad insertion.</p>
        pub fn set_live_pre_roll_configuration(
            mut self,
            input: std::option::Option<crate::model::LivePreRollConfiguration>,
        ) -> Self {
            self.live_pre_roll_configuration = input;
            self
        }
        /// <p>The Amazon CloudWatch log settings for a playback configuration.</p>
        pub fn log_configuration(mut self, input: crate::model::LogConfiguration) -> Self {
            self.log_configuration = Some(input);
            self
        }
        /// <p>The Amazon CloudWatch log settings for a playback configuration.</p>
        pub fn set_log_configuration(
            mut self,
            input: std::option::Option<crate::model::LogConfiguration>,
        ) -> Self {
            self.log_configuration = input;
            self
        }
        /// <p>The configuration for manifest processing rules. Manifest processing rules enable customization of the personalized manifests created by MediaTailor.</p>
        pub fn manifest_processing_rules(
            mut self,
            input: crate::model::ManifestProcessingRules,
        ) -> Self {
            self.manifest_processing_rules = Some(input);
            self
        }
        /// <p>The configuration for manifest processing rules. Manifest processing rules enable customization of the personalized manifests created by MediaTailor.</p>
        pub fn set_manifest_processing_rules(
            mut self,
            input: std::option::Option<crate::model::ManifestProcessingRules>,
        ) -> Self {
            self.manifest_processing_rules = input;
            self
        }
        /// <p>The identifier for the playback configuration.</p>
        pub fn name(mut self, input: impl Into<std::string::String>) -> Self {
            self.name = Some(input.into());
            self
        }
        /// <p>The identifier for the playback configuration.</p>
        pub fn set_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.name = input;
            self
        }
        /// <p>Defines the maximum duration of underfilled ad time (in seconds) allowed in an ad break. If the duration of underfilled ad time exceeds the personalization threshold, then the personalization of the ad break is abandoned and the underlying content is shown. This feature applies to <i>ad replacement</i> in live and VOD streams, rather than ad insertion, because it relies on an underlying content stream. For more information about ad break behavior, including ad replacement and insertion, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Behavior in AWS Elemental MediaTailor</a>.</p>
        pub fn personalization_threshold_seconds(mut self, input: i32) -> Self {
            self.personalization_threshold_seconds = Some(input);
            self
        }
        /// <p>Defines the maximum duration of underfilled ad time (in seconds) allowed in an ad break. If the duration of underfilled ad time exceeds the personalization threshold, then the personalization of the ad break is abandoned and the underlying content is shown. This feature applies to <i>ad replacement</i> in live and VOD streams, rather than ad insertion, because it relies on an underlying content stream. For more information about ad break behavior, including ad replacement and insertion, see <a href="https://docs.aws.amazon.com/mediatailor/latest/ug/ad-behavior.html">Ad Behavior in AWS Elemental MediaTailor</a>.</p>
        pub fn set_personalization_threshold_seconds(
            mut self,
            input: std::option::Option<i32>,
        ) -> Self {
            self.personalization_threshold_seconds = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) for the playback configuration.</p>
        pub fn playback_configuration_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.playback_configuration_arn = Some(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) for the playback configuration.</p>
        pub fn set_playback_configuration_arn(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.playback_configuration_arn = input;
            self
        }
        /// <p>The URL that the player accesses to get a manifest from AWS Elemental MediaTailor.</p>
        pub fn playback_endpoint_prefix(mut self, input: impl Into<std::string::String>) -> Self {
            self.playback_endpoint_prefix = Some(input.into());
            self
        }
        /// <p>The URL that the player accesses to get a manifest from AWS Elemental MediaTailor.</p>
        pub fn set_playback_endpoint_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.playback_endpoint_prefix = input;
            self
        }
        /// <p>The URL that the player uses to initialize a session that uses client-side reporting.</p>
        pub fn session_initialization_endpoint_prefix(
            mut self,
            input: impl Into<std::string::String>,
        ) -> Self {
            self.session_initialization_endpoint_prefix = Some(input.into());
            self
        }
        /// <p>The URL that the player uses to initialize a session that uses client-side reporting.</p>
        pub fn set_session_initialization_endpoint_prefix(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.session_initialization_endpoint_prefix = input;
            self
        }
        /// <p>The URL for a video asset to transcode and use to fill in time that's not used by ads. AWS Elemental MediaTailor shows the slate to fill in gaps in media content. Configuring the slate is optional for non-VPAID playback configurations. For VPAID, the slate is required because MediaTailor provides it in the slots designated for dynamic ad content. The slate must be a high-quality asset that contains both audio and video.</p>
        pub fn slate_ad_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.slate_ad_url = Some(input.into());
            self
        }
        /// <p>The URL for a video asset to transcode and use to fill in time that's not used by ads. AWS Elemental MediaTailor shows the slate to fill in gaps in media content. Configuring the slate is optional for non-VPAID playback configurations. For VPAID, the slate is required because MediaTailor provides it in the slots designated for dynamic ad content. The slate must be a high-quality asset that contains both audio and video.</p>
        pub fn set_slate_ad_url(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.slate_ad_url = input;
            self
        }
        /// Adds a key-value pair to `tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>The tags to assign to the playback configuration.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            let mut hash_map = self.tags.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.tags = Some(hash_map);
            self
        }
        /// <p>The tags to assign to the playback configuration.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.tags = input;
            self
        }
        /// <p>The name that is used to associate this playback configuration with a custom transcode profile. This overrides the dynamic transcoding defaults of MediaTailor. Use this only if you have already set up custom profiles with the help of AWS Support.</p>
        pub fn transcode_profile_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.transcode_profile_name = Some(input.into());
            self
        }
        /// <p>The name that is used to associate this playback configuration with a custom transcode profile. This overrides the dynamic transcoding defaults of MediaTailor. Use this only if you have already set up custom profiles with the help of AWS Support.</p>
        pub fn set_transcode_profile_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.transcode_profile_name = input;
            self
        }
        /// <p>The URL prefix for the parent manifest for the stream, minus the asset ID. The maximum length is 512 characters.</p>
        pub fn video_content_source_url(mut self, input: impl Into<std::string::String>) -> Self {
            self.video_content_source_url = Some(input.into());
            self
        }
        /// <p>The URL prefix for the parent manifest for the stream, minus the asset ID. The maximum length is 512 characters.</p>
        pub fn set_video_content_source_url(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.video_content_source_url = input;
            self
        }
        /// Consumes the builder and constructs a [`PlaybackConfiguration`](crate::model::PlaybackConfiguration)
        pub fn build(self) -> crate::model::PlaybackConfiguration {
            crate::model::PlaybackConfiguration {
                ad_decision_server_url: self.ad_decision_server_url,
                avail_suppression: self.avail_suppression,
                bumper: self.bumper,
                cdn_configuration: self.cdn_configuration,
                configuration_aliases: self.configuration_aliases,
                dash_configuration: self.dash_configuration,
                hls_configuration: self.hls_configuration,
                live_pre_roll_configuration: self.live_pre_roll_configuration,
                log_configuration: self.log_configuration,
                manifest_processing_rules: self.manifest_processing_rules,
                name: self.name,
                personalization_threshold_seconds: self
                    .personalization_threshold_seconds
                    .unwrap_or_default(),
                playback_configuration_arn: self.playback_configuration_arn,
                playback_endpoint_prefix: self.playback_endpoint_prefix,
                session_initialization_endpoint_prefix: self.session_initialization_endpoint_prefix,
                slate_ad_url: self.slate_ad_url,
                tags: self.tags,
                transcode_profile_name: self.transcode_profile_name,
                video_content_source_url: self.video_content_source_url,
            }
        }
    }
}
impl PlaybackConfiguration {
    /// Creates a new builder-style object to manufacture [`PlaybackConfiguration`](crate::model::PlaybackConfiguration)
    pub fn builder() -> crate::model::playback_configuration::Builder {
        crate::model::playback_configuration::Builder::default()
    }
}

/// <p>The configuration parameters for a channel.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct Channel {
    /// <p>The ARN of the channel.</p>
    pub arn: std::option::Option<std::string::String>,
    /// <p>The name of the channel.</p>
    pub channel_name: std::option::Option<std::string::String>,
    /// <p>Returns the state whether the channel is running or not.</p>
    pub channel_state: std::option::Option<std::string::String>,
    /// <p>The timestamp of when the channel was created.</p>
    pub creation_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>Contains information about the slate used to fill gaps between programs in the schedule. You must configure FillerSlate if your channel uses an LINEAR PlaybackMode.</p>
    pub filler_slate: std::option::Option<crate::model::SlateSource>,
    /// <p>The timestamp of when the channel was last modified.</p>
    pub last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The channel's output properties.</p>
    pub outputs: std::option::Option<std::vec::Vec<crate::model::ResponseOutputItem>>,
    /// <p>The type of playback mode for this channel.</p> <p>LINEAR - Programs play back-to-back only once.</p> <p>LOOP - Programs play back-to-back in an endless loop. When the last program in the schedule plays, playback loops back to the first program in the schedule.</p>
    pub playback_mode: std::option::Option<std::string::String>,
    /// <p>The tags to assign to the channel.</p>
    pub tags:
        std::option::Option<std::collections::HashMap<std::string::String, std::string::String>>,
}
impl Channel {
    /// <p>The ARN of the channel.</p>
    pub fn arn(&self) -> std::option::Option<&str> {
        self.arn.as_deref()
    }
    /// <p>The name of the channel.</p>
    pub fn channel_name(&self) -> std::option::Option<&str> {
        self.channel_name.as_deref()
    }
    /// <p>Returns the state whether the channel is running or not.</p>
    pub fn channel_state(&self) -> std::option::Option<&str> {
        self.channel_state.as_deref()
    }
    /// <p>The timestamp of when the channel was created.</p>
    pub fn creation_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.creation_time.as_ref()
    }
    /// <p>Contains information about the slate used to fill gaps between programs in the schedule. You must configure FillerSlate if your channel uses an LINEAR PlaybackMode.</p>
    pub fn filler_slate(&self) -> std::option::Option<&crate::model::SlateSource> {
        self.filler_slate.as_ref()
    }
    /// <p>The timestamp of when the channel was last modified.</p>
    pub fn last_modified_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.last_modified_time.as_ref()
    }
    /// <p>The channel's output properties.</p>
    pub fn outputs(&self) -> std::option::Option<&[crate::model::ResponseOutputItem]> {
        self.outputs.as_deref()
    }
    /// <p>The type of playback mode for this channel.</p> <p>LINEAR - Programs play back-to-back only once.</p> <p>LOOP - Programs play back-to-back in an endless loop. When the last program in the schedule plays, playback loops back to the first program in the schedule.</p>
    pub fn playback_mode(&self) -> std::option::Option<&str> {
        self.playback_mode.as_deref()
    }
    /// <p>The tags to assign to the channel.</p>
    pub fn tags(
        &self,
    ) -> std::option::Option<&std::collections::HashMap<std::string::String, std::string::String>>
    {
        self.tags.as_ref()
    }
}
impl std::fmt::Debug for Channel {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("Channel");
        formatter.field("arn", &self.arn);
        formatter.field("channel_name", &self.channel_name);
        formatter.field("channel_state", &self.channel_state);
        formatter.field("creation_time", &self.creation_time);
        formatter.field("filler_slate", &self.filler_slate);
        formatter.field("last_modified_time", &self.last_modified_time);
        formatter.field("outputs", &self.outputs);
        formatter.field("playback_mode", &self.playback_mode);
        formatter.field("tags", &self.tags);
        formatter.finish()
    }
}
/// See [`Channel`](crate::model::Channel)
pub mod channel {
    /// A builder for [`Channel`](crate::model::Channel)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) arn: std::option::Option<std::string::String>,
        pub(crate) channel_name: std::option::Option<std::string::String>,
        pub(crate) channel_state: std::option::Option<std::string::String>,
        pub(crate) creation_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) filler_slate: std::option::Option<crate::model::SlateSource>,
        pub(crate) last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) outputs: std::option::Option<std::vec::Vec<crate::model::ResponseOutputItem>>,
        pub(crate) playback_mode: std::option::Option<std::string::String>,
        pub(crate) tags: std::option::Option<
            std::collections::HashMap<std::string::String, std::string::String>,
        >,
    }
    impl Builder {
        /// <p>The ARN of the channel.</p>
        pub fn arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.arn = Some(input.into());
            self
        }
        /// <p>The ARN of the channel.</p>
        pub fn set_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.arn = input;
            self
        }
        /// <p>The name of the channel.</p>
        pub fn channel_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.channel_name = Some(input.into());
            self
        }
        /// <p>The name of the channel.</p>
        pub fn set_channel_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.channel_name = input;
            self
        }
        /// <p>Returns the state whether the channel is running or not.</p>
        pub fn channel_state(mut self, input: impl Into<std::string::String>) -> Self {
            self.channel_state = Some(input.into());
            self
        }
        /// <p>Returns the state whether the channel is running or not.</p>
        pub fn set_channel_state(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.channel_state = input;
            self
        }
        /// <p>The timestamp of when the channel was created.</p>
        pub fn creation_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.creation_time = Some(input);
            self
        }
        /// <p>The timestamp of when the channel was created.</p>
        pub fn set_creation_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.creation_time = input;
            self
        }
        /// <p>Contains information about the slate used to fill gaps between programs in the schedule. You must configure FillerSlate if your channel uses an LINEAR PlaybackMode.</p>
        pub fn filler_slate(mut self, input: crate::model::SlateSource) -> Self {
            self.filler_slate = Some(input);
            self
        }
        /// <p>Contains information about the slate used to fill gaps between programs in the schedule. You must configure FillerSlate if your channel uses an LINEAR PlaybackMode.</p>
        pub fn set_filler_slate(
            mut self,
            input: std::option::Option<crate::model::SlateSource>,
        ) -> Self {
            self.filler_slate = input;
            self
        }
        /// <p>The timestamp of when the channel was last modified.</p>
        pub fn last_modified_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.last_modified_time = Some(input);
            self
        }
        /// <p>The timestamp of when the channel was last modified.</p>
        pub fn set_last_modified_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.last_modified_time = input;
            self
        }
        /// Appends an item to `outputs`.
        ///
        /// To override the contents of this collection use [`set_outputs`](Self::set_outputs).
        ///
        /// <p>The channel's output properties.</p>
        pub fn outputs(mut self, input: impl Into<crate::model::ResponseOutputItem>) -> Self {
            let mut v = self.outputs.unwrap_or_default();
            v.push(input.into());
            self.outputs = Some(v);
            self
        }
        /// <p>The channel's output properties.</p>
        pub fn set_outputs(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ResponseOutputItem>>,
        ) -> Self {
            self.outputs = input;
            self
        }
        /// <p>The type of playback mode for this channel.</p> <p>LINEAR - Programs play back-to-back only once.</p> <p>LOOP - Programs play back-to-back in an endless loop. When the last program in the schedule plays, playback loops back to the first program in the schedule.</p>
        pub fn playback_mode(mut self, input: impl Into<std::string::String>) -> Self {
            self.playback_mode = Some(input.into());
            self
        }
        /// <p>The type of playback mode for this channel.</p> <p>LINEAR - Programs play back-to-back only once.</p> <p>LOOP - Programs play back-to-back in an endless loop. When the last program in the schedule plays, playback loops back to the first program in the schedule.</p>
        pub fn set_playback_mode(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.playback_mode = input;
            self
        }
        /// Adds a key-value pair to `tags`.
        ///
        /// To override the contents of this collection use [`set_tags`](Self::set_tags).
        ///
        /// <p>The tags to assign to the channel.</p>
        pub fn tags(
            mut self,
            k: impl Into<std::string::String>,
            v: impl Into<std::string::String>,
        ) -> Self {
            let mut hash_map = self.tags.unwrap_or_default();
            hash_map.insert(k.into(), v.into());
            self.tags = Some(hash_map);
            self
        }
        /// <p>The tags to assign to the channel.</p>
        pub fn set_tags(
            mut self,
            input: std::option::Option<
                std::collections::HashMap<std::string::String, std::string::String>,
            >,
        ) -> Self {
            self.tags = input;
            self
        }
        /// Consumes the builder and constructs a [`Channel`](crate::model::Channel)
        pub fn build(self) -> crate::model::Channel {
            crate::model::Channel {
                arn: self.arn,
                channel_name: self.channel_name,
                channel_state: self.channel_state,
                creation_time: self.creation_time,
                filler_slate: self.filler_slate,
                last_modified_time: self.last_modified_time,
                outputs: self.outputs,
                playback_mode: self.playback_mode,
                tags: self.tags,
            }
        }
    }
}
impl Channel {
    /// Creates a new builder-style object to manufacture [`Channel`](crate::model::Channel)
    pub fn builder() -> crate::model::channel::Builder {
        crate::model::channel::Builder::default()
    }
}

/// <p>Alert configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct Alert {
    /// <p>The code for the alert. For example, NOT_PROCESSED.</p>
    pub alert_code: std::option::Option<std::string::String>,
    /// <p>If an alert is generated for a resource, an explanation of the reason for the alert.</p>
    pub alert_message: std::option::Option<std::string::String>,
    /// <p>The timestamp when the alert was last modified.</p>
    pub last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The Amazon Resource Names (ARNs) related to this alert.</p>
    pub related_resource_arns: std::option::Option<std::vec::Vec<std::string::String>>,
    /// <p>The Amazon Resource Name (ARN) of the resource.</p>
    pub resource_arn: std::option::Option<std::string::String>,
}
impl Alert {
    /// <p>The code for the alert. For example, NOT_PROCESSED.</p>
    pub fn alert_code(&self) -> std::option::Option<&str> {
        self.alert_code.as_deref()
    }
    /// <p>If an alert is generated for a resource, an explanation of the reason for the alert.</p>
    pub fn alert_message(&self) -> std::option::Option<&str> {
        self.alert_message.as_deref()
    }
    /// <p>The timestamp when the alert was last modified.</p>
    pub fn last_modified_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.last_modified_time.as_ref()
    }
    /// <p>The Amazon Resource Names (ARNs) related to this alert.</p>
    pub fn related_resource_arns(&self) -> std::option::Option<&[std::string::String]> {
        self.related_resource_arns.as_deref()
    }
    /// <p>The Amazon Resource Name (ARN) of the resource.</p>
    pub fn resource_arn(&self) -> std::option::Option<&str> {
        self.resource_arn.as_deref()
    }
}
impl std::fmt::Debug for Alert {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("Alert");
        formatter.field("alert_code", &self.alert_code);
        formatter.field("alert_message", &self.alert_message);
        formatter.field("last_modified_time", &self.last_modified_time);
        formatter.field("related_resource_arns", &self.related_resource_arns);
        formatter.field("resource_arn", &self.resource_arn);
        formatter.finish()
    }
}
/// See [`Alert`](crate::model::Alert)
pub mod alert {
    /// A builder for [`Alert`](crate::model::Alert)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) alert_code: std::option::Option<std::string::String>,
        pub(crate) alert_message: std::option::Option<std::string::String>,
        pub(crate) last_modified_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) related_resource_arns: std::option::Option<std::vec::Vec<std::string::String>>,
        pub(crate) resource_arn: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The code for the alert. For example, NOT_PROCESSED.</p>
        pub fn alert_code(mut self, input: impl Into<std::string::String>) -> Self {
            self.alert_code = Some(input.into());
            self
        }
        /// <p>The code for the alert. For example, NOT_PROCESSED.</p>
        pub fn set_alert_code(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.alert_code = input;
            self
        }
        /// <p>If an alert is generated for a resource, an explanation of the reason for the alert.</p>
        pub fn alert_message(mut self, input: impl Into<std::string::String>) -> Self {
            self.alert_message = Some(input.into());
            self
        }
        /// <p>If an alert is generated for a resource, an explanation of the reason for the alert.</p>
        pub fn set_alert_message(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.alert_message = input;
            self
        }
        /// <p>The timestamp when the alert was last modified.</p>
        pub fn last_modified_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.last_modified_time = Some(input);
            self
        }
        /// <p>The timestamp when the alert was last modified.</p>
        pub fn set_last_modified_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.last_modified_time = input;
            self
        }
        /// Appends an item to `related_resource_arns`.
        ///
        /// To override the contents of this collection use [`set_related_resource_arns`](Self::set_related_resource_arns).
        ///
        /// <p>The Amazon Resource Names (ARNs) related to this alert.</p>
        pub fn related_resource_arns(mut self, input: impl Into<std::string::String>) -> Self {
            let mut v = self.related_resource_arns.unwrap_or_default();
            v.push(input.into());
            self.related_resource_arns = Some(v);
            self
        }
        /// <p>The Amazon Resource Names (ARNs) related to this alert.</p>
        pub fn set_related_resource_arns(
            mut self,
            input: std::option::Option<std::vec::Vec<std::string::String>>,
        ) -> Self {
            self.related_resource_arns = input;
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the resource.</p>
        pub fn resource_arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.resource_arn = Some(input.into());
            self
        }
        /// <p>The Amazon Resource Name (ARN) of the resource.</p>
        pub fn set_resource_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.resource_arn = input;
            self
        }
        /// Consumes the builder and constructs a [`Alert`](crate::model::Alert)
        pub fn build(self) -> crate::model::Alert {
            crate::model::Alert {
                alert_code: self.alert_code,
                alert_message: self.alert_message,
                last_modified_time: self.last_modified_time,
                related_resource_arns: self.related_resource_arns,
                resource_arn: self.resource_arn,
            }
        }
    }
}
impl Alert {
    /// Creates a new builder-style object to manufacture [`Alert`](crate::model::Alert)
    pub fn builder() -> crate::model::alert::Builder {
        crate::model::alert::Builder::default()
    }
}

/// <p>The properties for a schedule.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ScheduleEntry {
    /// <p>The approximate duration of this program, in seconds.</p>
    pub approximate_duration_seconds: i64,
    /// <p>The approximate time that the program will start playing.</p>
    pub approximate_start_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The ARN of the program.</p>
    pub arn: std::option::Option<std::string::String>,
    /// <p>The name of the channel that uses this schedule.</p>
    pub channel_name: std::option::Option<std::string::String>,
    /// <p>The name of the program.</p>
    pub program_name: std::option::Option<std::string::String>,
    /// <p>The schedule's ad break properties.</p>
    pub schedule_ad_breaks: std::option::Option<std::vec::Vec<crate::model::ScheduleAdBreak>>,
    /// <p>The type of schedule entry.</p> <p>Valid values: PROGRAM or FILLER_SLATE.</p>
    pub schedule_entry_type: std::option::Option<crate::model::ScheduleEntryType>,
    /// <p>The name of the source location.</p>
    pub source_location_name: std::option::Option<std::string::String>,
    /// <p>The name of the VOD source.</p>
    pub vod_source_name: std::option::Option<std::string::String>,
}
impl ScheduleEntry {
    /// <p>The approximate duration of this program, in seconds.</p>
    pub fn approximate_duration_seconds(&self) -> i64 {
        self.approximate_duration_seconds
    }
    /// <p>The approximate time that the program will start playing.</p>
    pub fn approximate_start_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.approximate_start_time.as_ref()
    }
    /// <p>The ARN of the program.</p>
    pub fn arn(&self) -> std::option::Option<&str> {
        self.arn.as_deref()
    }
    /// <p>The name of the channel that uses this schedule.</p>
    pub fn channel_name(&self) -> std::option::Option<&str> {
        self.channel_name.as_deref()
    }
    /// <p>The name of the program.</p>
    pub fn program_name(&self) -> std::option::Option<&str> {
        self.program_name.as_deref()
    }
    /// <p>The schedule's ad break properties.</p>
    pub fn schedule_ad_breaks(&self) -> std::option::Option<&[crate::model::ScheduleAdBreak]> {
        self.schedule_ad_breaks.as_deref()
    }
    /// <p>The type of schedule entry.</p> <p>Valid values: PROGRAM or FILLER_SLATE.</p>
    pub fn schedule_entry_type(&self) -> std::option::Option<&crate::model::ScheduleEntryType> {
        self.schedule_entry_type.as_ref()
    }
    /// <p>The name of the source location.</p>
    pub fn source_location_name(&self) -> std::option::Option<&str> {
        self.source_location_name.as_deref()
    }
    /// <p>The name of the VOD source.</p>
    pub fn vod_source_name(&self) -> std::option::Option<&str> {
        self.vod_source_name.as_deref()
    }
}
impl std::fmt::Debug for ScheduleEntry {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ScheduleEntry");
        formatter.field(
            "approximate_duration_seconds",
            &self.approximate_duration_seconds,
        );
        formatter.field("approximate_start_time", &self.approximate_start_time);
        formatter.field("arn", &self.arn);
        formatter.field("channel_name", &self.channel_name);
        formatter.field("program_name", &self.program_name);
        formatter.field("schedule_ad_breaks", &self.schedule_ad_breaks);
        formatter.field("schedule_entry_type", &self.schedule_entry_type);
        formatter.field("source_location_name", &self.source_location_name);
        formatter.field("vod_source_name", &self.vod_source_name);
        formatter.finish()
    }
}
/// See [`ScheduleEntry`](crate::model::ScheduleEntry)
pub mod schedule_entry {
    /// A builder for [`ScheduleEntry`](crate::model::ScheduleEntry)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) approximate_duration_seconds: std::option::Option<i64>,
        pub(crate) approximate_start_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) arn: std::option::Option<std::string::String>,
        pub(crate) channel_name: std::option::Option<std::string::String>,
        pub(crate) program_name: std::option::Option<std::string::String>,
        pub(crate) schedule_ad_breaks:
            std::option::Option<std::vec::Vec<crate::model::ScheduleAdBreak>>,
        pub(crate) schedule_entry_type: std::option::Option<crate::model::ScheduleEntryType>,
        pub(crate) source_location_name: std::option::Option<std::string::String>,
        pub(crate) vod_source_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The approximate duration of this program, in seconds.</p>
        pub fn approximate_duration_seconds(mut self, input: i64) -> Self {
            self.approximate_duration_seconds = Some(input);
            self
        }
        /// <p>The approximate duration of this program, in seconds.</p>
        pub fn set_approximate_duration_seconds(mut self, input: std::option::Option<i64>) -> Self {
            self.approximate_duration_seconds = input;
            self
        }
        /// <p>The approximate time that the program will start playing.</p>
        pub fn approximate_start_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.approximate_start_time = Some(input);
            self
        }
        /// <p>The approximate time that the program will start playing.</p>
        pub fn set_approximate_start_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.approximate_start_time = input;
            self
        }
        /// <p>The ARN of the program.</p>
        pub fn arn(mut self, input: impl Into<std::string::String>) -> Self {
            self.arn = Some(input.into());
            self
        }
        /// <p>The ARN of the program.</p>
        pub fn set_arn(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.arn = input;
            self
        }
        /// <p>The name of the channel that uses this schedule.</p>
        pub fn channel_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.channel_name = Some(input.into());
            self
        }
        /// <p>The name of the channel that uses this schedule.</p>
        pub fn set_channel_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.channel_name = input;
            self
        }
        /// <p>The name of the program.</p>
        pub fn program_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.program_name = Some(input.into());
            self
        }
        /// <p>The name of the program.</p>
        pub fn set_program_name(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.program_name = input;
            self
        }
        /// Appends an item to `schedule_ad_breaks`.
        ///
        /// To override the contents of this collection use [`set_schedule_ad_breaks`](Self::set_schedule_ad_breaks).
        ///
        /// <p>The schedule's ad break properties.</p>
        pub fn schedule_ad_breaks(
            mut self,
            input: impl Into<crate::model::ScheduleAdBreak>,
        ) -> Self {
            let mut v = self.schedule_ad_breaks.unwrap_or_default();
            v.push(input.into());
            self.schedule_ad_breaks = Some(v);
            self
        }
        /// <p>The schedule's ad break properties.</p>
        pub fn set_schedule_ad_breaks(
            mut self,
            input: std::option::Option<std::vec::Vec<crate::model::ScheduleAdBreak>>,
        ) -> Self {
            self.schedule_ad_breaks = input;
            self
        }
        /// <p>The type of schedule entry.</p> <p>Valid values: PROGRAM or FILLER_SLATE.</p>
        pub fn schedule_entry_type(mut self, input: crate::model::ScheduleEntryType) -> Self {
            self.schedule_entry_type = Some(input);
            self
        }
        /// <p>The type of schedule entry.</p> <p>Valid values: PROGRAM or FILLER_SLATE.</p>
        pub fn set_schedule_entry_type(
            mut self,
            input: std::option::Option<crate::model::ScheduleEntryType>,
        ) -> Self {
            self.schedule_entry_type = input;
            self
        }
        /// <p>The name of the source location.</p>
        pub fn source_location_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_location_name = Some(input.into());
            self
        }
        /// <p>The name of the source location.</p>
        pub fn set_source_location_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_location_name = input;
            self
        }
        /// <p>The name of the VOD source.</p>
        pub fn vod_source_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.vod_source_name = Some(input.into());
            self
        }
        /// <p>The name of the VOD source.</p>
        pub fn set_vod_source_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vod_source_name = input;
            self
        }
        /// Consumes the builder and constructs a [`ScheduleEntry`](crate::model::ScheduleEntry)
        pub fn build(self) -> crate::model::ScheduleEntry {
            crate::model::ScheduleEntry {
                approximate_duration_seconds: self.approximate_duration_seconds.unwrap_or_default(),
                approximate_start_time: self.approximate_start_time,
                arn: self.arn,
                channel_name: self.channel_name,
                program_name: self.program_name,
                schedule_ad_breaks: self.schedule_ad_breaks,
                schedule_entry_type: self.schedule_entry_type,
                source_location_name: self.source_location_name,
                vod_source_name: self.vod_source_name,
            }
        }
    }
}
impl ScheduleEntry {
    /// Creates a new builder-style object to manufacture [`ScheduleEntry`](crate::model::ScheduleEntry)
    pub fn builder() -> crate::model::schedule_entry::Builder {
        crate::model::schedule_entry::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum ScheduleEntryType {
    #[allow(missing_docs)] // documentation missing in model
    FillerSlate,
    #[allow(missing_docs)] // documentation missing in model
    Program,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for ScheduleEntryType {
    fn from(s: &str) -> Self {
        match s {
            "FILLER_SLATE" => ScheduleEntryType::FillerSlate,
            "PROGRAM" => ScheduleEntryType::Program,
            other => ScheduleEntryType::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for ScheduleEntryType {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(ScheduleEntryType::from(s))
    }
}
impl ScheduleEntryType {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            ScheduleEntryType::FillerSlate => "FILLER_SLATE",
            ScheduleEntryType::Program => "PROGRAM",
            ScheduleEntryType::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["FILLER_SLATE", "PROGRAM"]
    }
}
impl AsRef<str> for ScheduleEntryType {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>The schedule's ad break properties.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ScheduleAdBreak {
    /// <p>The approximate duration of the ad break, in seconds.</p>
    pub approximate_duration_seconds: i64,
    /// <p>The approximate time that the ad will start playing.</p>
    pub approximate_start_time: std::option::Option<aws_smithy_types::DateTime>,
    /// <p>The name of the source location containing the VOD source used for the ad break.</p>
    pub source_location_name: std::option::Option<std::string::String>,
    /// <p>The name of the VOD source used for the ad break.</p>
    pub vod_source_name: std::option::Option<std::string::String>,
}
impl ScheduleAdBreak {
    /// <p>The approximate duration of the ad break, in seconds.</p>
    pub fn approximate_duration_seconds(&self) -> i64 {
        self.approximate_duration_seconds
    }
    /// <p>The approximate time that the ad will start playing.</p>
    pub fn approximate_start_time(&self) -> std::option::Option<&aws_smithy_types::DateTime> {
        self.approximate_start_time.as_ref()
    }
    /// <p>The name of the source location containing the VOD source used for the ad break.</p>
    pub fn source_location_name(&self) -> std::option::Option<&str> {
        self.source_location_name.as_deref()
    }
    /// <p>The name of the VOD source used for the ad break.</p>
    pub fn vod_source_name(&self) -> std::option::Option<&str> {
        self.vod_source_name.as_deref()
    }
}
impl std::fmt::Debug for ScheduleAdBreak {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ScheduleAdBreak");
        formatter.field(
            "approximate_duration_seconds",
            &self.approximate_duration_seconds,
        );
        formatter.field("approximate_start_time", &self.approximate_start_time);
        formatter.field("source_location_name", &self.source_location_name);
        formatter.field("vod_source_name", &self.vod_source_name);
        formatter.finish()
    }
}
/// See [`ScheduleAdBreak`](crate::model::ScheduleAdBreak)
pub mod schedule_ad_break {
    /// A builder for [`ScheduleAdBreak`](crate::model::ScheduleAdBreak)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) approximate_duration_seconds: std::option::Option<i64>,
        pub(crate) approximate_start_time: std::option::Option<aws_smithy_types::DateTime>,
        pub(crate) source_location_name: std::option::Option<std::string::String>,
        pub(crate) vod_source_name: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The approximate duration of the ad break, in seconds.</p>
        pub fn approximate_duration_seconds(mut self, input: i64) -> Self {
            self.approximate_duration_seconds = Some(input);
            self
        }
        /// <p>The approximate duration of the ad break, in seconds.</p>
        pub fn set_approximate_duration_seconds(mut self, input: std::option::Option<i64>) -> Self {
            self.approximate_duration_seconds = input;
            self
        }
        /// <p>The approximate time that the ad will start playing.</p>
        pub fn approximate_start_time(mut self, input: aws_smithy_types::DateTime) -> Self {
            self.approximate_start_time = Some(input);
            self
        }
        /// <p>The approximate time that the ad will start playing.</p>
        pub fn set_approximate_start_time(
            mut self,
            input: std::option::Option<aws_smithy_types::DateTime>,
        ) -> Self {
            self.approximate_start_time = input;
            self
        }
        /// <p>The name of the source location containing the VOD source used for the ad break.</p>
        pub fn source_location_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.source_location_name = Some(input.into());
            self
        }
        /// <p>The name of the source location containing the VOD source used for the ad break.</p>
        pub fn set_source_location_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.source_location_name = input;
            self
        }
        /// <p>The name of the VOD source used for the ad break.</p>
        pub fn vod_source_name(mut self, input: impl Into<std::string::String>) -> Self {
            self.vod_source_name = Some(input.into());
            self
        }
        /// <p>The name of the VOD source used for the ad break.</p>
        pub fn set_vod_source_name(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.vod_source_name = input;
            self
        }
        /// Consumes the builder and constructs a [`ScheduleAdBreak`](crate::model::ScheduleAdBreak)
        pub fn build(self) -> crate::model::ScheduleAdBreak {
            crate::model::ScheduleAdBreak {
                approximate_duration_seconds: self.approximate_duration_seconds.unwrap_or_default(),
                approximate_start_time: self.approximate_start_time,
                source_location_name: self.source_location_name,
                vod_source_name: self.vod_source_name,
            }
        }
    }
}
impl ScheduleAdBreak {
    /// Creates a new builder-style object to manufacture [`ScheduleAdBreak`](crate::model::ScheduleAdBreak)
    pub fn builder() -> crate::model::schedule_ad_break::Builder {
        crate::model::schedule_ad_break::Builder::default()
    }
}

/// <p>Ad break configuration parameters.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct AdBreak {
    /// <p>The SCTE-35 ad insertion type. Accepted value: SPLICE_INSERT.</p>
    pub message_type: std::option::Option<crate::model::MessageType>,
    /// <p>How long (in milliseconds) after the beginning of the program that an ad starts. This value must fall within 100ms of a segment boundary, otherwise the ad break will be skipped.</p>
    pub offset_millis: i64,
    /// <p>Ad break slate configuration.</p>
    pub slate: std::option::Option<crate::model::SlateSource>,
    /// <p>This defines the SCTE-35 splice_insert() message inserted around the ad. For information about using splice_insert(), see the SCTE-35 specficiaiton, section 9.7.3.1.</p>
    pub splice_insert_message: std::option::Option<crate::model::SpliceInsertMessage>,
}
impl AdBreak {
    /// <p>The SCTE-35 ad insertion type. Accepted value: SPLICE_INSERT.</p>
    pub fn message_type(&self) -> std::option::Option<&crate::model::MessageType> {
        self.message_type.as_ref()
    }
    /// <p>How long (in milliseconds) after the beginning of the program that an ad starts. This value must fall within 100ms of a segment boundary, otherwise the ad break will be skipped.</p>
    pub fn offset_millis(&self) -> i64 {
        self.offset_millis
    }
    /// <p>Ad break slate configuration.</p>
    pub fn slate(&self) -> std::option::Option<&crate::model::SlateSource> {
        self.slate.as_ref()
    }
    /// <p>This defines the SCTE-35 splice_insert() message inserted around the ad. For information about using splice_insert(), see the SCTE-35 specficiaiton, section 9.7.3.1.</p>
    pub fn splice_insert_message(&self) -> std::option::Option<&crate::model::SpliceInsertMessage> {
        self.splice_insert_message.as_ref()
    }
}
impl std::fmt::Debug for AdBreak {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("AdBreak");
        formatter.field("message_type", &self.message_type);
        formatter.field("offset_millis", &self.offset_millis);
        formatter.field("slate", &self.slate);
        formatter.field("splice_insert_message", &self.splice_insert_message);
        formatter.finish()
    }
}
/// See [`AdBreak`](crate::model::AdBreak)
pub mod ad_break {
    /// A builder for [`AdBreak`](crate::model::AdBreak)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) message_type: std::option::Option<crate::model::MessageType>,
        pub(crate) offset_millis: std::option::Option<i64>,
        pub(crate) slate: std::option::Option<crate::model::SlateSource>,
        pub(crate) splice_insert_message: std::option::Option<crate::model::SpliceInsertMessage>,
    }
    impl Builder {
        /// <p>The SCTE-35 ad insertion type. Accepted value: SPLICE_INSERT.</p>
        pub fn message_type(mut self, input: crate::model::MessageType) -> Self {
            self.message_type = Some(input);
            self
        }
        /// <p>The SCTE-35 ad insertion type. Accepted value: SPLICE_INSERT.</p>
        pub fn set_message_type(
            mut self,
            input: std::option::Option<crate::model::MessageType>,
        ) -> Self {
            self.message_type = input;
            self
        }
        /// <p>How long (in milliseconds) after the beginning of the program that an ad starts. This value must fall within 100ms of a segment boundary, otherwise the ad break will be skipped.</p>
        pub fn offset_millis(mut self, input: i64) -> Self {
            self.offset_millis = Some(input);
            self
        }
        /// <p>How long (in milliseconds) after the beginning of the program that an ad starts. This value must fall within 100ms of a segment boundary, otherwise the ad break will be skipped.</p>
        pub fn set_offset_millis(mut self, input: std::option::Option<i64>) -> Self {
            self.offset_millis = input;
            self
        }
        /// <p>Ad break slate configuration.</p>
        pub fn slate(mut self, input: crate::model::SlateSource) -> Self {
            self.slate = Some(input);
            self
        }
        /// <p>Ad break slate configuration.</p>
        pub fn set_slate(mut self, input: std::option::Option<crate::model::SlateSource>) -> Self {
            self.slate = input;
            self
        }
        /// <p>This defines the SCTE-35 splice_insert() message inserted around the ad. For information about using splice_insert(), see the SCTE-35 specficiaiton, section 9.7.3.1.</p>
        pub fn splice_insert_message(mut self, input: crate::model::SpliceInsertMessage) -> Self {
            self.splice_insert_message = Some(input);
            self
        }
        /// <p>This defines the SCTE-35 splice_insert() message inserted around the ad. For information about using splice_insert(), see the SCTE-35 specficiaiton, section 9.7.3.1.</p>
        pub fn set_splice_insert_message(
            mut self,
            input: std::option::Option<crate::model::SpliceInsertMessage>,
        ) -> Self {
            self.splice_insert_message = input;
            self
        }
        /// Consumes the builder and constructs a [`AdBreak`](crate::model::AdBreak)
        pub fn build(self) -> crate::model::AdBreak {
            crate::model::AdBreak {
                message_type: self.message_type,
                offset_millis: self.offset_millis.unwrap_or_default(),
                slate: self.slate,
                splice_insert_message: self.splice_insert_message,
            }
        }
    }
}
impl AdBreak {
    /// Creates a new builder-style object to manufacture [`AdBreak`](crate::model::AdBreak)
    pub fn builder() -> crate::model::ad_break::Builder {
        crate::model::ad_break::Builder::default()
    }
}

/// <p>Splice insert message configuration.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct SpliceInsertMessage {
    /// <p>This is written to splice_insert.avail_num, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub avail_num: i32,
    /// <p>This is written to splice_insert.avails_expected, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub avails_expected: i32,
    /// <p>This is written to splice_insert.splice_event_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 1.</p>
    pub splice_event_id: i32,
    /// <p>This is written to splice_insert.unique_program_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub unique_program_id: i32,
}
impl SpliceInsertMessage {
    /// <p>This is written to splice_insert.avail_num, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub fn avail_num(&self) -> i32 {
        self.avail_num
    }
    /// <p>This is written to splice_insert.avails_expected, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub fn avails_expected(&self) -> i32 {
        self.avails_expected
    }
    /// <p>This is written to splice_insert.splice_event_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 1.</p>
    pub fn splice_event_id(&self) -> i32 {
        self.splice_event_id
    }
    /// <p>This is written to splice_insert.unique_program_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
    pub fn unique_program_id(&self) -> i32 {
        self.unique_program_id
    }
}
impl std::fmt::Debug for SpliceInsertMessage {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("SpliceInsertMessage");
        formatter.field("avail_num", &self.avail_num);
        formatter.field("avails_expected", &self.avails_expected);
        formatter.field("splice_event_id", &self.splice_event_id);
        formatter.field("unique_program_id", &self.unique_program_id);
        formatter.finish()
    }
}
/// See [`SpliceInsertMessage`](crate::model::SpliceInsertMessage)
pub mod splice_insert_message {
    /// A builder for [`SpliceInsertMessage`](crate::model::SpliceInsertMessage)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) avail_num: std::option::Option<i32>,
        pub(crate) avails_expected: std::option::Option<i32>,
        pub(crate) splice_event_id: std::option::Option<i32>,
        pub(crate) unique_program_id: std::option::Option<i32>,
    }
    impl Builder {
        /// <p>This is written to splice_insert.avail_num, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn avail_num(mut self, input: i32) -> Self {
            self.avail_num = Some(input);
            self
        }
        /// <p>This is written to splice_insert.avail_num, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn set_avail_num(mut self, input: std::option::Option<i32>) -> Self {
            self.avail_num = input;
            self
        }
        /// <p>This is written to splice_insert.avails_expected, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn avails_expected(mut self, input: i32) -> Self {
            self.avails_expected = Some(input);
            self
        }
        /// <p>This is written to splice_insert.avails_expected, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn set_avails_expected(mut self, input: std::option::Option<i32>) -> Self {
            self.avails_expected = input;
            self
        }
        /// <p>This is written to splice_insert.splice_event_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 1.</p>
        pub fn splice_event_id(mut self, input: i32) -> Self {
            self.splice_event_id = Some(input);
            self
        }
        /// <p>This is written to splice_insert.splice_event_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 1.</p>
        pub fn set_splice_event_id(mut self, input: std::option::Option<i32>) -> Self {
            self.splice_event_id = input;
            self
        }
        /// <p>This is written to splice_insert.unique_program_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn unique_program_id(mut self, input: i32) -> Self {
            self.unique_program_id = Some(input);
            self
        }
        /// <p>This is written to splice_insert.unique_program_id, as defined in section 9.7.3.1 of the SCTE-35 specification. The default value is 0. Values must be between 0 and 256, inclusive.</p>
        pub fn set_unique_program_id(mut self, input: std::option::Option<i32>) -> Self {
            self.unique_program_id = input;
            self
        }
        /// Consumes the builder and constructs a [`SpliceInsertMessage`](crate::model::SpliceInsertMessage)
        pub fn build(self) -> crate::model::SpliceInsertMessage {
            crate::model::SpliceInsertMessage {
                avail_num: self.avail_num.unwrap_or_default(),
                avails_expected: self.avails_expected.unwrap_or_default(),
                splice_event_id: self.splice_event_id.unwrap_or_default(),
                unique_program_id: self.unique_program_id.unwrap_or_default(),
            }
        }
    }
}
impl SpliceInsertMessage {
    /// Creates a new builder-style object to manufacture [`SpliceInsertMessage`](crate::model::SpliceInsertMessage)
    pub fn builder() -> crate::model::splice_insert_message::Builder {
        crate::model::splice_insert_message::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum MessageType {
    #[allow(missing_docs)] // documentation missing in model
    SpliceInsert,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for MessageType {
    fn from(s: &str) -> Self {
        match s {
            "SPLICE_INSERT" => MessageType::SpliceInsert,
            other => MessageType::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for MessageType {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(MessageType::from(s))
    }
}
impl MessageType {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            MessageType::SpliceInsert => "SPLICE_INSERT",
            MessageType::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["SPLICE_INSERT"]
    }
}
impl AsRef<str> for MessageType {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

/// <p>Schedule configuration parameters. A channel must be stopped before changes can be made to the schedule.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct ScheduleConfiguration {
    /// <p>Program transition configurations.</p>
    pub transition: std::option::Option<crate::model::Transition>,
}
impl ScheduleConfiguration {
    /// <p>Program transition configurations.</p>
    pub fn transition(&self) -> std::option::Option<&crate::model::Transition> {
        self.transition.as_ref()
    }
}
impl std::fmt::Debug for ScheduleConfiguration {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("ScheduleConfiguration");
        formatter.field("transition", &self.transition);
        formatter.finish()
    }
}
/// See [`ScheduleConfiguration`](crate::model::ScheduleConfiguration)
pub mod schedule_configuration {
    /// A builder for [`ScheduleConfiguration`](crate::model::ScheduleConfiguration)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) transition: std::option::Option<crate::model::Transition>,
    }
    impl Builder {
        /// <p>Program transition configurations.</p>
        pub fn transition(mut self, input: crate::model::Transition) -> Self {
            self.transition = Some(input);
            self
        }
        /// <p>Program transition configurations.</p>
        pub fn set_transition(
            mut self,
            input: std::option::Option<crate::model::Transition>,
        ) -> Self {
            self.transition = input;
            self
        }
        /// Consumes the builder and constructs a [`ScheduleConfiguration`](crate::model::ScheduleConfiguration)
        pub fn build(self) -> crate::model::ScheduleConfiguration {
            crate::model::ScheduleConfiguration {
                transition: self.transition,
            }
        }
    }
}
impl ScheduleConfiguration {
    /// Creates a new builder-style object to manufacture [`ScheduleConfiguration`](crate::model::ScheduleConfiguration)
    pub fn builder() -> crate::model::schedule_configuration::Builder {
        crate::model::schedule_configuration::Builder::default()
    }
}

/// <p>Program transition configuration.</p>
#[non_exhaustive]
#[derive(std::clone::Clone, std::cmp::PartialEq)]
pub struct Transition {
    /// <p>The position where this program will be inserted relative to the RelativePosition.</p>
    pub relative_position: std::option::Option<crate::model::RelativePosition>,
    /// <p>The name of the program that this program will be inserted next to, as defined by RelativePosition.</p>
    pub relative_program: std::option::Option<std::string::String>,
    /// <p>The date and time that the program is scheduled to start, in epoch milliseconds.</p>
    pub scheduled_start_time_millis: i64,
    /// <p>Defines when the program plays in the schedule. You can set the value to ABSOLUTE or RELATIVE.</p> <p>ABSOLUTE - The program plays at a specific wall clock time. This setting can only be used for channels using the LINEAR PlaybackMode.</p> <p>Note the following considerations when using ABSOLUTE transitions:</p> <p>If the preceding program in the schedule has a duration that extends past the wall clock time, MediaTailor truncates the preceding program on a common segment boundary.</p> <p>If there are gaps in playback, MediaTailor plays the FillerSlate you configured for your linear channel.</p> <p>RELATIVE - The program is inserted into the schedule either before or after a program that you specify via RelativePosition.</p>
    pub r#type: std::option::Option<std::string::String>,
}
impl Transition {
    /// <p>The position where this program will be inserted relative to the RelativePosition.</p>
    pub fn relative_position(&self) -> std::option::Option<&crate::model::RelativePosition> {
        self.relative_position.as_ref()
    }
    /// <p>The name of the program that this program will be inserted next to, as defined by RelativePosition.</p>
    pub fn relative_program(&self) -> std::option::Option<&str> {
        self.relative_program.as_deref()
    }
    /// <p>The date and time that the program is scheduled to start, in epoch milliseconds.</p>
    pub fn scheduled_start_time_millis(&self) -> i64 {
        self.scheduled_start_time_millis
    }
    /// <p>Defines when the program plays in the schedule. You can set the value to ABSOLUTE or RELATIVE.</p> <p>ABSOLUTE - The program plays at a specific wall clock time. This setting can only be used for channels using the LINEAR PlaybackMode.</p> <p>Note the following considerations when using ABSOLUTE transitions:</p> <p>If the preceding program in the schedule has a duration that extends past the wall clock time, MediaTailor truncates the preceding program on a common segment boundary.</p> <p>If there are gaps in playback, MediaTailor plays the FillerSlate you configured for your linear channel.</p> <p>RELATIVE - The program is inserted into the schedule either before or after a program that you specify via RelativePosition.</p>
    pub fn r#type(&self) -> std::option::Option<&str> {
        self.r#type.as_deref()
    }
}
impl std::fmt::Debug for Transition {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        let mut formatter = f.debug_struct("Transition");
        formatter.field("relative_position", &self.relative_position);
        formatter.field("relative_program", &self.relative_program);
        formatter.field(
            "scheduled_start_time_millis",
            &self.scheduled_start_time_millis,
        );
        formatter.field("r#type", &self.r#type);
        formatter.finish()
    }
}
/// See [`Transition`](crate::model::Transition)
pub mod transition {
    /// A builder for [`Transition`](crate::model::Transition)
    #[non_exhaustive]
    #[derive(std::default::Default, std::clone::Clone, std::cmp::PartialEq, std::fmt::Debug)]
    pub struct Builder {
        pub(crate) relative_position: std::option::Option<crate::model::RelativePosition>,
        pub(crate) relative_program: std::option::Option<std::string::String>,
        pub(crate) scheduled_start_time_millis: std::option::Option<i64>,
        pub(crate) r#type: std::option::Option<std::string::String>,
    }
    impl Builder {
        /// <p>The position where this program will be inserted relative to the RelativePosition.</p>
        pub fn relative_position(mut self, input: crate::model::RelativePosition) -> Self {
            self.relative_position = Some(input);
            self
        }
        /// <p>The position where this program will be inserted relative to the RelativePosition.</p>
        pub fn set_relative_position(
            mut self,
            input: std::option::Option<crate::model::RelativePosition>,
        ) -> Self {
            self.relative_position = input;
            self
        }
        /// <p>The name of the program that this program will be inserted next to, as defined by RelativePosition.</p>
        pub fn relative_program(mut self, input: impl Into<std::string::String>) -> Self {
            self.relative_program = Some(input.into());
            self
        }
        /// <p>The name of the program that this program will be inserted next to, as defined by RelativePosition.</p>
        pub fn set_relative_program(
            mut self,
            input: std::option::Option<std::string::String>,
        ) -> Self {
            self.relative_program = input;
            self
        }
        /// <p>The date and time that the program is scheduled to start, in epoch milliseconds.</p>
        pub fn scheduled_start_time_millis(mut self, input: i64) -> Self {
            self.scheduled_start_time_millis = Some(input);
            self
        }
        /// <p>The date and time that the program is scheduled to start, in epoch milliseconds.</p>
        pub fn set_scheduled_start_time_millis(mut self, input: std::option::Option<i64>) -> Self {
            self.scheduled_start_time_millis = input;
            self
        }
        /// <p>Defines when the program plays in the schedule. You can set the value to ABSOLUTE or RELATIVE.</p> <p>ABSOLUTE - The program plays at a specific wall clock time. This setting can only be used for channels using the LINEAR PlaybackMode.</p> <p>Note the following considerations when using ABSOLUTE transitions:</p> <p>If the preceding program in the schedule has a duration that extends past the wall clock time, MediaTailor truncates the preceding program on a common segment boundary.</p> <p>If there are gaps in playback, MediaTailor plays the FillerSlate you configured for your linear channel.</p> <p>RELATIVE - The program is inserted into the schedule either before or after a program that you specify via RelativePosition.</p>
        pub fn r#type(mut self, input: impl Into<std::string::String>) -> Self {
            self.r#type = Some(input.into());
            self
        }
        /// <p>Defines when the program plays in the schedule. You can set the value to ABSOLUTE or RELATIVE.</p> <p>ABSOLUTE - The program plays at a specific wall clock time. This setting can only be used for channels using the LINEAR PlaybackMode.</p> <p>Note the following considerations when using ABSOLUTE transitions:</p> <p>If the preceding program in the schedule has a duration that extends past the wall clock time, MediaTailor truncates the preceding program on a common segment boundary.</p> <p>If there are gaps in playback, MediaTailor plays the FillerSlate you configured for your linear channel.</p> <p>RELATIVE - The program is inserted into the schedule either before or after a program that you specify via RelativePosition.</p>
        pub fn set_type(mut self, input: std::option::Option<std::string::String>) -> Self {
            self.r#type = input;
            self
        }
        /// Consumes the builder and constructs a [`Transition`](crate::model::Transition)
        pub fn build(self) -> crate::model::Transition {
            crate::model::Transition {
                relative_position: self.relative_position,
                relative_program: self.relative_program,
                scheduled_start_time_millis: self.scheduled_start_time_millis.unwrap_or_default(),
                r#type: self.r#type,
            }
        }
    }
}
impl Transition {
    /// Creates a new builder-style object to manufacture [`Transition`](crate::model::Transition)
    pub fn builder() -> crate::model::transition::Builder {
        crate::model::transition::Builder::default()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum RelativePosition {
    #[allow(missing_docs)] // documentation missing in model
    AfterProgram,
    #[allow(missing_docs)] // documentation missing in model
    BeforeProgram,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for RelativePosition {
    fn from(s: &str) -> Self {
        match s {
            "AFTER_PROGRAM" => RelativePosition::AfterProgram,
            "BEFORE_PROGRAM" => RelativePosition::BeforeProgram,
            other => RelativePosition::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for RelativePosition {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(RelativePosition::from(s))
    }
}
impl RelativePosition {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            RelativePosition::AfterProgram => "AFTER_PROGRAM",
            RelativePosition::BeforeProgram => "BEFORE_PROGRAM",
            RelativePosition::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["AFTER_PROGRAM", "BEFORE_PROGRAM"]
    }
}
impl AsRef<str> for RelativePosition {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}

#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(
    std::clone::Clone,
    std::cmp::Eq,
    std::cmp::Ord,
    std::cmp::PartialEq,
    std::cmp::PartialOrd,
    std::fmt::Debug,
    std::hash::Hash,
)]
pub enum PlaybackMode {
    #[allow(missing_docs)] // documentation missing in model
    Linear,
    #[allow(missing_docs)] // documentation missing in model
    Loop,
    /// Unknown contains new variants that have been added since this code was generated.
    Unknown(String),
}
impl std::convert::From<&str> for PlaybackMode {
    fn from(s: &str) -> Self {
        match s {
            "LINEAR" => PlaybackMode::Linear,
            "LOOP" => PlaybackMode::Loop,
            other => PlaybackMode::Unknown(other.to_owned()),
        }
    }
}
impl std::str::FromStr for PlaybackMode {
    type Err = std::convert::Infallible;

    fn from_str(s: &str) -> std::result::Result<Self, Self::Err> {
        Ok(PlaybackMode::from(s))
    }
}
impl PlaybackMode {
    /// Returns the `&str` value of the enum member.
    pub fn as_str(&self) -> &str {
        match self {
            PlaybackMode::Linear => "LINEAR",
            PlaybackMode::Loop => "LOOP",
            PlaybackMode::Unknown(s) => s.as_ref(),
        }
    }
    /// Returns all the `&str` values of the enum members.
    pub fn values() -> &'static [&'static str] {
        &["LINEAR", "LOOP"]
    }
}
impl AsRef<str> for PlaybackMode {
    fn as_ref(&self) -> &str {
        self.as_str()
    }
}
